unit Hero;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ddraw, DDSD, dddd, ddddut, ddidex,
  defs, shkernel, moveUtil, enemy, flare, zangai, SE, s_MathPack,Primitives;


type THero = class(TMover)
  private
    //BackFire:TBackFire;   //obNt@CA
    mySpr:Integer;          //\XvCgԍ
    RecentDX:Integer;       //ŋ߂Xւ̓B
    PrevShot:Boolean;       //1t[ÕVbg{^̏
    PrevShotT:Integer;      //ŌɃVbg
    Invincible:Boolean;     //G?
    EndInvincibleT:DWord;   //GI
    RailState:Integer;      //[K̔ˏ
    FlyPath:Array[0..4] of TVector2D; //ꂽɔł鎞̋O
  public
    constructor Create(owner:TMoverList);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnCrush(Target:TMover); override; //Փˎ̃Cxg
    procedure OnDie; override;
    procedure OnDamaged(dmg:Integer); override;
    procedure BecomeInvincible(t:Integer);      //GɂȂ
end;

type TNormalShot = class(TMover)
  private
    Pat:Integer;
    //mySpr:Integer;    //\XvCgԍ
    vx,vy:Integer;    //ړ
  public
    constructor Create(owner:TMoverList; anim:Integer; gx,gy,_vx,_vy:Integer);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnCrush(Target:TMover); override; //Փˎ̃Cxg
    procedure OnDie; override;
end;

//[K
type TRailGun = class(TMover)
  private
    mySpr:Array[0..4] of Integer;    //\XvCgԍ
    vx,vy:Integer;    //ړ
  public
    constructor Create(owner:TMoverList; gx,gy,_vx,_vy:Integer);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnCrush(Target:TMover); override; //Փˎ̃Cxg
    procedure OnDie; override;
end;

//[U[
type THeroLaser = class(TMover)
  private
    v0:TVector2D; //
    pos:Array[0..7] of TVector2D; //e֐߂̈ʒu
    colorTbl:Array[0..7] of DWord; //Fe[u
    TargetID:Integer;           //^[QbgID
  public
    constructor Create(owner:TMoverList; gx,gy:Integer; v:TVector2D);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy, n:Integer); //WE֐߂Jグ鐔
    procedure OnCrush(Target:TMover); override; //Փˎ̃Cxg
    procedure OnDie; override;
    procedure OnPaint;  override;               //JX^`
end;


//qbg}[N
type THitMark1 = class(TFlare)
  private
    vx,vy:Single;  //x
  public
    constructor Create(owner:TMoverList; gx,gy:Integer; dx,dy:Single);
    procedure Move(t:Integer); override;
    procedure OnShow; override;
end;

type THitMark2 = class(TMover)
  private
    vx,vy:Single;  //x
  public
    constructor Create(owner:TMoverList; gx,gy:Integer; dx,dy:Single);
    procedure Move(t:Integer); override;
end;

type THitMark3 = class(TMover)
  private
    vx,vy:Single;  //x
  public
    constructor Create(owner:TMoverList; gx,gy:Integer; dx,dy:Single);
    procedure Move(t:Integer); override;
end;


implementation

////////////////////////////
// q[[
////////////////////////////
constructor THero.Create(owner:TMoverList);
begin
  inherited;

  RailState:=0;

  //蔻̏
  FAttr:=maHero;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-8,-8,+8,+8);

  //GԂŐ܂B
  BecomeInvincible(180);  //ŏ3b͖G

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=S_HERO;
    MinAnim:=-2;
    MaxAnim:=+2;
    iAnim:=0;
    Visible:=True;
    Z:=Z_NORMAL;
  end;

  FlyPath[0]:=Vector2D(240,520);
  FlyPath[1]:=Vector2D(260,300);
  FlyPath[2]:=Vector2D(280,160);
  FlyPath[3]:=Vector2D(300,280);
  FlyPath[4]:=Vector2D(320,400);

  MoveTo(80,520);

//  BackFire:=TBackFire.Create(FOwner,FOwner.Tick,S_BFHERO);
//  BackFire.MoveTo(X,Y+8);

//  FOwner.Add(BackFire);
end;


destructor THero.Destroy;
begin
  FOwner.FreeSprite(mySpr);

  inherited;
end;


//GɂȂ
procedure THero.BecomeInvincible(t:Integer);
begin
  EndInvincibleT:=AgeT+t;
  Invincible:=True;
end;


procedure THero.Move(t:Integer);
var
  dx,dy:Integer;
  curP:TVector2D;
  iFire:Integer;  //ǂ̕ׂ
begin
  inherited;

  //GԂ̏
  if AgeT > EndInvincibleT then begin
    Invincible:=False;
    FOwner.Spr[mySpr].IShape := S_HERO;
  end;

  if Invincible then begin
    if (FOwner.NCalled And 1 = 0) then
      FOwner.Spr[mySpr].IShape := S_HERO
    else
      FOwner.Spr[mySpr].IShape := S_HERO + 5;
  end;

  //ꂽɂƂłf
  if (AgeT-60 < T_FLY) And (AgeT >= 60) then begin
    curP:=MvInterpolate(FlyPath, AgeT-60, T_FLY);
    with FOwner.Spr[mySpr] do begin
      Width:=(T_FLY-AgeT+60)*2 + 64;
      Height:=Width;
      Z:=Z_TOP;
      IAnim:=1;
    end;
    MoveTo(Round(curP.X),Round(CurP.Y));
  end;


  //^CAbv
  if (FOwner.RestTime < 0) And (FOwner.GameState = gsGame) then begin
    //ĎŁB
    FOwner.Add(TDyingHero.Create(FOwner, X,Y));
    if not FDead then begin
      FOwner.HeroDie;
      Die;
    end;
  end;

  //XeBbNňړcAAof͈ړs
  if AgeT-60 < T_FLY then
    Exit;

  with FOwner.Spr[mySpr] do begin
    ResetSize;
    Z:=Z_NORMAL;
  end;

  //if not REPLAY then begin
    //蓮
    if USE_ANALOG then begin
      Joy.DeadZone:=5;
      dx:=Joy.AStick.X*9*t div 32768;
      dy:=Joy.AStick.Y*9*t div 32768;
    end else begin
      Joy.DeadZone:=33;
      dx:=Joy.Stick.X*6*t;
      dy:=Joy.Stick.Y*6*t;
    end;
  {
  end else begin
    //vC
    dx:=ReplayData[IReplay].dx;
    dy:=ReplayData[IReplay].dy;
  end;
  }

  Inc(X,dx);
  Inc(Y,dy);

  if X<32 then
    x:=32;
  if Y<32 then
    y:=32;
  if x>608 then
    x:=608;
  if y>448 then
    y:=448;

  moveTo(x,y);

  //XeBbN̍Eŋ@̂X
  RecentDX:=MvBreaking(RecentDX,4*t);
  Inc(RecentDX,dx * 4 div 3);
  RecentDX:=MvLimitation(RecentDX,40);
  FOwner.Spr[mySpr].IAnim:=RecentDX div 20;


  //ׂ̌
  //if not REPLAY then begin
    iFire:=-1;

    if ( Joy.Buttons[BTN_SHOT3] Or (Joy.Buttons[BTN_SHOT2] And Joy.Buttons[BTN_SHOT]) ) then
      iFire:=2 //[U[
    else if Joy.Buttons[BTN_SHOT] then
      iFire:=0 //m[}Vbg
    else if Joy.Buttons[BTN_SHOT2] then
      iFire:=1;  //[K

    //̘A˔\͂ɉāA˂邩ۂǔ
    case iFire of
      0: if (PrevShot And (AgeT-PrevShotT < 4)) then iFire:=-1;
      1: if (PrevShot And (AgeT-PrevShotT < 3)) then iFire:=-1;
      2: if (PrevShot And (AgeT-PrevShotT < 5)) then iFire:=-1;
    end;

  {
  end else begin
    iFire:=ReplayData[IReplay].Fired;
  end;
  }

  PrevShot:=Joy.Buttons[BTN_SHOT] Or Joy.Buttons[BTN_SHOT2] Or Joy.Buttons[BTN_SHOT3];

  case iFire of
    0: begin   //m[}Vbg
      PrevShotT:=AgeT;

      FOwner.Add(TNormalShot.Create(FOwner, 0, x-8,y-4,   0,-16));
      FOwner.Add(TNormalShot.Create(FOwner, 0, x+8,y-4,   0,-16));

      FOwner.Add(TNormalShot.Create(FOwner, 0, x-14,y-2,   0,-16));
      FOwner.Add(TNormalShot.Create(FOwner, 0, x+14,y-2,   0,-16));


      FOwner.Add(TNormalShot.Create(FOwner, 1, x-8,y-4,  -7,-14));  //30x
      //FOwner.Add(TNormalShot.Create(FOwner, 2, x-8,y-4, -12,-12));  //45x

      FOwner.Add(TNormalShot.Create(FOwner, 3, x+8,y-4,  +7,-14));  //E30x
      //FOwner.Add(TNormalShot.Create(FOwner, 4, x+8,y-4, +12,-12));  //E45x

      //ʉ
      SG.Play(CH_HERO1,PR_NORMAL, SE_SHOT1);
    end;

    1: begin  //[K
      PrevShotT:=AgeT;

      //OɃVbg
      FOwner.Add(TNormalShot.Create(FOwner, 0, x-8,y-4,   0,-16));
      FOwner.Add(TNormalShot.Create(FOwner, 0, x+8,y-4,   0,-16));

      //ʉ
      SG.Play(CH_HERO1,PR_NORMAL, SE_SHOT1);

      //Ƀ[K
      if (not PrevShot) And (RailState=0) then
        RailState:=1;

      if RailState > 0 then begin
        if RailState = 1 then
          FOwner.Add(TRailGun.Create(FOwner, X+8,Y+40, 0,30))
        else if RailState = 2 then
          FOwner.Add(TRailGun.Create(FOwner, X-8,Y+40, 0,30));

        //ʉ
        SG.Play(CH_HERO2,PR_NORMAL, SE_SHOT2);
      end;

      Inc(RailState);

      if RailState > 2 then
        RailState := 0;
    end;

    2: begin  //V[J[C
      PrevShotT:=AgeT;

      FOwner.Add(THeroLaser.Create(FOwner,X,Y-4, Vector2D(0,-40)));
    end;
  end;


  {
  //vCf[^ɋL
  if not REPLAY then begin
    FOWner.FrameInfo.dx:=dx;
    FOwner.FrameInfo.dy:=dy;
    FOwner.FrameInfo.Fired:=iFire;
  end;
  }

//  BackFire.MoveTo(X,Y+8);
end;

procedure THero.MoveTo(xx,yy:Integer);
begin
  FOwner.HeroPos:=Point(xx,yy);
  x:=xx;
  y:=yy;
  with FOwner.Spr[mySpr] do begin
    FOwner.Spr[mySpr].X:=xx - Width Shr 1;
    FOwner.Spr[mySpr].Y:=yy - Height Shr 1;
  end;
end;

procedure THero.OnCrush(Target:TMover);
begin
  //Gɑ̓肷ƁA50pt̃_[W(ʏԂ̂)
  if (Target.Attr = maEnemy) And (not Invincible) then begin
    Target.OnDamaged(50);
  end else if (Target.Attr = maEB) And (not (moEnemyLaser in Target.SubAttr))  then begin
    //e͎Ȃ
    Target.Die;
  end;
end;

procedure THero.OnDie;
begin
  inherited;


  FOwner.Spr[mySpr].Hide;
//  BackFire.Die;
end;

procedure THero.OnDamaged(dmg:Integer);
begin
  if Invincible Then
    Exit;

  //lȂ̂ŁAꌂŔ
  FOwner.Add(TDyingHero.Create(FOwner, X,Y));

  {
  if FOwner.Score < 20000 then
    FOwner.Score := FOwner.Score - 10000
  else
    FOwner.Score:=FOwner.Score div 2;
  }
  //t[ŁAe𕡐HꍇA2Die鎖ɂȂ̂ŁAŃ`FbN
  if not FDead then begin
    FOwner.HeroDie;
    Die;
  end;
end;




////////////////////////////
// m[}Vbg
////////////////////////////
constructor TNormalShot.Create(owner:TMoverList; anim:Integer; gx,gy,_vx,_vy:Integer);
begin
  inherited Create(owner);

  //蔻̏
  FAttr:=maHB;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-8,-16,+8,16);

  vx:=_vx;
  vy:=_vy;

  Pat:=P_TAMA1 + anim;

  {
  //XvCgVFCv̏
  //mySpr:=FOWner.NewSprite();
  with FOwner.Spr[mySpr] do begin
    iShape:=S_TAMA1;
    MinAnim:=0;
    MaxAnim:=anim;
    iAnim:=anim;
    Visible:=True;
    Z:=Z_SHOT;
  end;
  }
  MoveTo(gx,gy);

end;

destructor TNormalShot.Destroy;
begin
  //FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TNormalShot.Move(t:Integer);
begin
  Inc(X,vx * t);
  Inc(Y,vy * t);

  MoveTo(x,y);

  //FOwner.Spr[mySpr].NextFrame;

  if (Y < -32) Or (X < -32) Or (X > 672) then begin
    //FOwner.Spr[mySpr].Hide;
    Die();
  end;
end;

procedure TNormalShot.MoveTo(xx,yy:Integer);
var
  width:Integer;  //p^[̔̕
begin
  x:=xx;
  y:=yy;

  if Pat = P_TAMA1 then
    width:=8
  else
    width:=16;

  FOwner.Rend.PushPatternRect(Pat, SingleRect(x-width,y-16,x+width,y+16), Z_SHOT, bmAdd, $FFFFFFFF);
  //FOwner.Spr[mySpr].X:=x-FOwner.Spr[mySpr].Width Shr 1;
  //FOwner.Spr[mySpr].Y:=y-16;
end;

procedure TNormalShot.OnCrush(Target:TMover); //Փˎ̃Cxg
begin
  if Target.attr=maEnemy then begin

    //΂̕U炷Aqbg}[No
    if not (moNoSpark in Target.SubAttr) then begin
      FOwner.Add(TSpark2.Create(FOwner, 1, 768,160,X,Y));
      FOwner.Add(THitMark2.Create(FOwner, X,Y,0,0));// vx / 4, vy / 4));
    end;
    //͂A_[W
    Target.OnDamaged(1);

    //ʉ
    SG.Play(CH_ENEMY1,PR_LOWER,SE_Hit1);
  end;
  Die;
end;

procedure TNormalShot.OnDie;
begin
  inherited;

  //FOwner.Spr[mySpr].Hide;
end;




////////////////////////////
// [K
////////////////////////////
constructor TRailGun.Create(owner:TMoverList; gx,gy,_vx,_vy:Integer);
var
  i:Integer;
begin
  inherited Create(owner);

  //蔻̏
  FAttr:=maHB;
  HP:=8;
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-8,-32,+8,48);

  vx:=_vx;
  vy:=_vy;

  //XvCgVFCv̏
  For i:=0 to 4 do begin
    mySpr[i]:=FOWner.NewSprite();
    with FOwner.Spr[mySpr[i]] do begin
      iShape:=S_RAILGUN;
      MinAnim:=0;
      MaxAnim:=2;
      iAnim:=0;
      Visible:= True;
      Z:=Z_SHOT;
    end;
  end;
  MoveTo(gx,gy);
end;

destructor TRailGun.Destroy;
var
  i:Integer;
begin
  For i:=0 to 4 do
    FOwner.FreeSprite(mySpr[i]);
  inherited;
end;

procedure TRailGun.Move(t:Integer);
var
  i:Integer;
begin
  inherited;

  Inc(X,vx * t);
  Inc(Y,vy * t);

  MoveTo(x,y);

  if AgeT > 8 then begin
    For i:=0 to 4 do
      FOwner.Spr[mySpr[i]].IAnim:=2;
  end else if AgeT > 2 then begin
    For i:=0 to 4 do
      FOwner.Spr[mySpr[i]].IAnim:=1;
  end;

  //FOwner.Spr[mySpr].NextFrame;

  if (Y < -32) Or (Y>530) Or (X < -32) Or (X > 672) then begin
    For i:=0 to 4 do
      FOwner.Spr[mySpr[i]].Hide;
    Die();
  end;
end;

procedure TRailGun.MoveTo(xx,yy:Integer);
var
  i:Integer;
begin
  x:=xx;
  y:=yy;
  For i:= 0 to 4 do begin
    FOwner.Spr[mySpr[i]].X:=x-8;
    FOwner.Spr[mySpr[i]].Y:=y-32 + (i*16);
  end;
end;

procedure TRailGun.OnCrush(Target:TMover); //Փˎ̃Cxg
var
  i:Integer;
  p:TVector2D;
begin
  if Target.attr=maEnemy then begin

    //ʉ
    SG.Play(CH_ENEMY1,PR_LOWER,SE_Hit1);

    //΂̕U炷Aqbg}[N
    if not (moNoSpark in Target.SubAttr) then
      FOwner.Add(TSpark2.Create(FOwner, 8, 768,160,X,Y));
      For i:=0 to 7 do begin
        p:=MvRandomRot(Vector2D(vx,vy),80,vy);
        FOwner.Add(THitMark2.Create(FOwner, X,Y, p.x / 4, p.y / 4));
      end;
    //͂A_[W
    Target.OnDamaged(HP);
  end;

  Dec(HP,target.HP);
  if HP <= 0 then
    Die;
end;

procedure TRailGun.OnDie;
var
  i:Integer;
begin
  inherited;

  For i:= 0 to 4 do
    FOwner.Spr[mySpr[i]].Hide;
end;





////////////////////////////
// [U[
////////////////////////////
constructor THeroLaser.Create(owner:TMoverList; gx,gy:Integer; v:TVector2D);
var
  i:Integer;
begin
  inherited Create(owner);

  //Eʒȗ
  v0:=v;

  For i:=0 to High(pos) do
    pos[i]:=Vector2D(gx,gy);

  //蔻Ƃ̏
  HP:=16;
  FAttr:=maEraser;
  nTouchRect:=High(pos)-1;

  MoveTo(gx,gy,1);

  //蔻pɁAʂ̐΍Wg
  X:=0;
  Y:=0;

  //J[e[u̍쐬
  For i:=0 to 7 do begin
    colorTbl[i]:=QD.ARGBToPhysical(255, 32 * (7-i),32 * (7-i),255);
  end;

  TargetID:=-1;
end;

destructor THeroLaser.Destroy;
begin
  inherited;
end;

procedure THeroLaser.Move(t:Integer);
var
  i,j:Integer;
  e:TMover;
  dx,dy:Single;
  d,min_d,min_idx:Integer; //ԋ߂G܂ł̋,ԋ߂G̃CfNX
  newTarget:Integer; //Vȃ^[Qbg
  myX,myY:Integer;   //݈ʒu
  tmpPos:Array[0..1,0..High(pos)] of TVector2D;
  ofs:TVector2D;     //z[~OC̕`ʒu
  function ABS(x:Integer):Integer;
  begin
    if x<0 then
      result:=-x
    else
      result:=x;
  end;
begin
  inherited;

  {
  //i
  pos[0].X:=pos[0].X + v0.X * t;
  pos[0].Y:=pos[0].Y + v0.Y * t;
  }

  min_d:=10000;
  min_idx:=-1;
  myX:=Round(Pos[0].X);
  myY:=Round(Pos[0].Y);

  //GɌGO!
  if TargetID = -1 then begin
    //GTă^[QbeBO
    For i:=0 to FOwner.Count-1 do begin
      e:=FOwner.Movers[i];
      if (e.Attr = maEB) And (not (moTarget in e.SubAttr)) then begin
        //Ȃׂ߂GT
        d:=ABS(e.X - myX) + ABS(e.Y - myY);
        if min_d > d then begin
          min_d:=d;
          min_idx:=i;
        end;
      end;
    end;
    //^[QbeBO
    if min_idx <> -1 then begin
      e:=FOwner.Movers[min_idx];
      e.SubAttr := e.SubAttr + [moTarget];
      TargetID:=e.ID;

      dx:=e.X - pos[0].X;
      dy:=e.Y - pos[0].Y;
      //v0:=MvNormalize(Vector2D(dx,dy),40.0*t);
      v0:=MvNormalize(Vector2D(dx,dy),40.0 + 10 * t);
    end;

  end else begin
    //^[QbgɌĈ꒼
    For i:=0 to FOwner.Count-1 do begin
      e:=FOwner.Movers[i];
      if (e.Attr = maEB) And (e.ID = TargetID) then begin
        dx:=e.X - pos[0].X;
        dy:=e.Y - pos[0].Y;
        //v0:=MvNormalize(Vector2D(dx,dy),40.0*t);
        v0:=MvNormalize(Vector2D(dx,dy),40.0 + 10 * t);
        break;
      end;
    end;
  end;


  pos[0].X:=pos[0].X + v0.X ;//* t;
  pos[0].Y:=pos[0].Y + v0.Y ;//* t;

  MoveTo(Round(pos[0].X),Round(pos[0].Y), t);


  //`
  For i:=0 to 1 do
    For j:=0 to High(pos) do
      tmpPos[i,j]:=Vector2D(pos[j].X+MvRandom(8),pos[j].Y+MvRandom(8));

  For i:=0 to 1 do begin
    For j:=0 to High(pos)-1 do begin

      ofs:=NowSub2D(tmpPos[i,j+1],tmpPos[i,j]);
      ofs:=NowChangeLength2D(Vector2D(-ofs.Y,ofs.X),8.0);


      FOwner.Rend.PushPattern2D(P_THUNDER,
                                NowSub2D(tmpPos[i,j+1],ofs),NowAdd2D(tmpPos[i,j+1],ofs),NowSub2D(tmpPos[i,j],ofs),NowAdd2D(tmpPos[i,j],ofs),
                                Z_FLARE,
                                bmAdd,
                                NowScaleColor($FFFFFFFF,2.0-j/High(pos)*1.5));
      //FOwner.Rend.PushPattern2D(P_THUNDER,[Vector2D(0,0),Vector2D(32,0),Vector2D(0,128),Vector2D(32,128)],Z_FLARE,bmAdd,$FFFFFFFF);
    end;
  end;

end;

procedure THeroLaser.MoveTo(xx,yy, n:Integer);
var
  i:Integer;
  bOver:Boolean;
begin

  //[
  For i:=High(pos) downto n do
    pos[i]:=pos[i-1];

  For i:=0 to n-1 do
    pos[i]:=Vector2D(xx,yy);

  {
  For i:=High(pos)-n+1 to High(pos) do
    pos[i]:=pos[High(pos)-n];
  }

  //_
  For i:=0 to High(pos) do begin
    pos[i].X:=pos[i].X + Random * 32.0 - 16.0;
    pos[i].Y:=pos[i].Y + Random * 32.0 - 16.0;
  end;

  //蔻̌vZ
  For i:=0 to High(pos)-1 do begin
    FTouchRect[i]:=MvRegulateRect(Rect(Round(pos[i].X),Round(pos[i].Y),Round(pos[i+1].X),Round(pos[i+1].Y)));
  end;

  //͂ꔻc֐߂̑SʊOɏoĂA
  bOver:=True;
  For i:=0 to High(pos) do begin
    if (pos[i].X > -20) And (pos[i].X < 660) And (pos[i].Y > -20) And (pos[i].Y < 500) then
      bOver:=False;
  end;

  if bOver then
    Die;

end;

procedure THeroLaser.OnCrush(Target:TMover);
var
  i:Integer;
  e:TMover;
  p:TVector2D;
  pt:TPoint;
  dmg:Integer;
begin
  inherited;

  if Target.attr=maEB then begin

    pt:=Point(Round(pos[0].X),Round(pos[0].Y));

    //ʉ
    //SG.Play(CH_ENEMY1,PR_LOWER,SE_Hit1);

    //΂̕U炷Aqbg}[N
    if not (moNoSpark in Target.SubAttr) then
      FOwner.Add(TSpark2.Create(FOwner, 1, 768,160,pt.X,pt.Y));

    {
    For i:=0 to 3 do begin
      p:=MvRot(v0,i*256,v0.y);
      FOwner.Add(THitMark1.Create(FOwner, pt.X,pt.Y, p.x / 30, p.y / 30));
    end;
    }
    FOwner.Add(THitmark3.Create(FOwner, pt.X,pt.Y, 0,0));

    //^[QbgƂȂĂG}[N͂
    For i:=0 to FOwner.Count-1 do begin
      e:=FOwner.Movers[i];
      if e.ID = TargetID then begin
        e.SubAttr := e.SubAttr - [moTarget];
        TargetID:=-1; //VȓGT
        break;
      end;
    end;

    //e
    Dec(HP);
    Target.OnDamaged(dmg);
    if HP <= 0 then
      Die;
  end;

end;

procedure THeroLaser.OnDie;
var
  i:Integer;
  e:TMover;
begin
  //^[QbgƂȂĂG}[N͂
  For i:=0 to FOwner.Count-1 do begin
    e:=FOwner.Movers[i];
    if e.ID = TargetID then begin
      e.SubAttr := e.SubAttr - [moTarget];
      break;
    end;
  end;

  inherited;
end;

procedure THeroLaser.OnPaint;
var
  pt:Array[0..High(pos)] of TPoint;
  i:Integer;
  ddsd:DDSurfaceDesc2;
  pSurf:pWord;  //VRAMւ̃|C^
  pPix:pWord;
  lPitch:DWord;

  //`悷郋[`
  procedure Line(x1,y1,x2,y2:Integer; col:DWord);
  var
    dx,dy,step:Integer;
    t,k1,k2,e:Integer;
    procedure Pset(x,y,col:Integer);
    begin
      if (x < 0) Or (x>639) Or (y<0) Or (y>479) then
        Exit;
      pPix:=pSurf;
      Inc(pPix,lPitch * y + x);
      pPix^:=col;
    end;
  begin

    if y1>y2 then begin
      t:=y2;  y2:=y1;  y1:=t;
      t:=x2;  x2:=x1;  x1:=t;
    end;

    dx:=x2-x1;
    dy:=y2-y1;

    if dx>0 then
      step:=1
    else	begin
      dx:=-dx;
      step:=-1;
    end;

    if dx>dy then begin
      k1:=dy Shl 2;
      k2:=k1-(dx Shl 2);
      e:=k1-dx;


      Pset(x1,y1,col);

      while dx >= 0do begin
        if e>=0 then begin
        	Inc(y1);
          Inc(e,k2);
        end else begin
          Inc(e,k1);
        end;
        Inc(x1,step);
        Pset(x1,y1,col);
        Dec(dx);
      end;

    end else begin
      k1:=dx Shl 2;
      k2:=k1-(dy Shl 2);
      e:=k1-dy;

      Pset(x1,y1,col);

      while dy >= 0do begin
        if e>=0 then begin
        	Inc(x1,step);
          Inc(e,k2);
        end else begin
        	Inc(e,k1);
        end;
        Inc(y1);
        Pset(x1,y1,col);
        Dec(dy);
      end;
    end;

  end;

begin

  //DrawPrimitiveŘd悤ɂȂAȂĂ悢
  Exit;

  //W̕ϊ
  For i:=0 to High(pos) do begin
    pt[i].X:=Round(pos[i].X);
    pt[i].Y:=Round(pos[i].Y);
  end;

  //Ōq
  if not QD.BackBuffer.IsLost then begin
    //bN
    QD.BackBuffer.Lock(ddsd);
    pSurf:=ddsd.lpSurface;
    lPitch:=ddsd.lPitch Shr 1;

    For i:=0 to High(pos)-1 do begin
      Line(pt[i].X,pt[i].Y,pt[i+1].X,pt[i+1].Y, colorTbl[i]);
      Line(pt[i].X+MvRandom(8),pt[i].Y+MvRandom(8),pt[i+1].X+MvRandom(8),pt[i+1].Y+MvRandom(8), colorTbl[i]);
    end;

    QD.backBuffer.Unlock;
  end;

  {
  ddc.PenPos:=pt[0];
  For i:=1 to High(pos) do begin
    ddc.Pen.Color:=colorTbl[i];
    ddc.LineTo(pt[i].X,pt[i].Y);
    ddc.PenPos:=pt[i];
  end;

  ddc.Free;
  }

end;


////////////////////////////
// qbg}[N
////////////////////////////

constructor THitMark1.Create(owner:TMoverList; gx,gy:Integer; dx,dy:Single);
begin
  inherited Create(owner, gx,gy, S_HIT1, 0);
  vx:=dx;
  vy:=dy;
end;

procedure THitMark1.OnShow;
begin
  with FOwner.Spr[mySpr] do begin
    MinAnim:=0;
    MaxAnim:=3;
    iAnim:=0;
    Visible:=True;
  end;
end;

procedure THitMark1.Move(t:Integer);
begin
  inherited;

  if Showed then begin
    if CanShootConst(0, 15) then begin
      FOwner.Spr[mySpr].IAnim:=FOwner.Spr[mySpr].IAnim + 1;
      if FOwner.Spr[mySpr].IAnim > FOwner.Spr[mySpr].MaxAnim then begin
        FOwner.Spr[mySpr].IAnim:=0;
        Die;
      end else
    end;
    MoveTo(X + Round(vx*t),Y + Round(vy*t));
  end;
end;

////////////////////////////
// qbg}[N2(eNX`)
////////////////////////////


constructor THitMark2.Create(owner:TMoverList; gx,gy:Integer; dx,dy:Single);
begin
  inherited Create(owner);

  vx:=dx;
  vy:=dy;
  X:=gx;
  Y:=gy;
end;

procedure THitMark2.Move(t:Integer);
var
  size:Single;
  color:DWord;
begin
  inherited;

  if AgeT > 15 then
    Die;

  X:=X + Round(vx * t);
  Y:=Y + Round(vy * t);

  //Ȋ
  size:=4.0 + (AgeT / 15.0 * 8.0);
  color:=NowScaleColor($FFFFB050,1.0 - AgeT / 15.0);

  //ŌɌc͂߂Ƃ܂(^^;)
  //if AgeT = 15 then
  //  color:=$FFFFFFFF;

  FOwner.Rend.PushPattern2D(P_BALL,
                            Vector2D(X-size,Y-size),Vector2D(X+size,Y-size), Vector2D(X-size,Y+size),Vector2D(X+size,Y+size),
                            Z_FLARE,
                            bmAdd,
                            color);

end;


////////////////////////////
// qbg}[N3(eNX`E)
////////////////////////////


constructor THitMark3.Create(owner:TMoverList; gx,gy:Integer; dx,dy:Single);
begin
  inherited Create(owner);

  vx:=dx;
  vy:=dy;
  X:=gx;
  Y:=gy;
end;

procedure THitMark3.Move(t:Integer);
var
  size:Single;
  color:DWord;
begin
  inherited;

  if AgeT > 15 then
    Die;

  X:=X + Round(vx * t);
  Y:=Y + Round(vy * t);

  //Ȋ
  size:=12.0 + AgeT;
  color:=NowScaleColor($FF50B0FF,1.0 - AgeT / 15.0);

  //ŌɌc͂߂Ƃ܂(^^;)
  //if AgeT = 15 then
  //  color:=$FFFFFFFF;

  FOwner.Rend.PushPatternRect(P_RING,
                            SingleRect(x-size,y-size,x+size,y+size),
                            Z_FLARE,
                            bmAdd,
                            color);

end;


end.
