unit s_util;

{SANDMAN'S utilities}


//RDTSC߂gȂCyrix CPUƂ̎lƁAłˁB
//{$DEFINE NOT_INTEL}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  INIFiles;

procedure DPF(x:String);
procedure DPF2(x:String;mt:TMsgDlgType);
procedure NPF(x:String);
procedure NPF2(x:String;mt:TMsgDlgType);
procedure DP_Start(fname:String);
procedure DPS(x:String);
procedure DP_End;


function  SUT_ININame:string; //ftHgINIt@C̖O
function  SUT_AppPath:String; //Av̒uĂfBNg
function  SUT_ImgPath:String; //摜t@C̒uĂftHg̃fBNg
procedure SUT_SaveFormPos(iniName:String; section:String; frm:TForm); //tH[ʒu̓ǂݏ
procedure SUT_LoadFormPos(iniName:String; section:String; frm:TForm);
procedure SUT_RegulateFormPos(frm:TForm);  //tH[̂߂荞݂𒼂
procedure SUT_Qsort(var a:Array of Integer);   //QuickSort֐
procedure SUT_QsortStrings(strs:TStrings);       //QuickSort֐
procedure SUT_QsortStringsDown(strs:TStrings);   //~QuickSort֐

//ȉ́APentium,PentiumProp(6x86)
function GetCLK:Comp;



//IIntArray
type TDynIntArray = Class
  private
    FContent:PInteger;  //z̒g
    function getItem(idx:Integer):Integer;
    procedure setItem(idx,v:Integer);
  public
    constructor Create(nElem:Integer);
    destructor Destroy; override;
    property Items[idx:Integer]:Integer read getItem write setItem; default;
end;

//IIntArray(2D)
type TDynIntArray2D = Class
  private
    FContent:PInteger;  //z̒g
    FShiftFactor:Integer; //񎟌ڂ߂ƂɁAǂꂾVtgׂ
    function getItem(idx1,idx2:Integer):Integer;
    procedure setItem(idx1,idx2,v:Integer);
  public
    constructor Create(nElem1,nElem2:Integer);
    destructor Destroy; override;
    property Items[idx1,idx2:Integer]:Integer read getItem write setItem; default;
end;

implementation

var
  F:TextFile;

//QuickSort֐
procedure SUT_Qsort(var a:Array of Integer);
var
  s,t,i,j:Integer;
  procedure QSort(left,right:Integer);
  begin
    if (left<right) then begin
      s:=a[(left+right) Shr 1];
      i:=left-1;
      j:=right+1;
      while True do begin

        repeat
          Inc(i);
        until (a[i]>=s);

        repeat
          Dec(j);
        until (a[j]<=s);

        if (i>=j) then
          break;

        t:=a[i];
        a[i]:=a[j];
        a[j]:=t;
      end;
      QSort(left,i-1);
      QSort(j+1,right);
    end;
  end;
begin
  QSort(Low(a),High(a));
end;


//QuickSort֐(񃊃Xg)
procedure SUT_QsortStrings(strs:TStrings);
var
  s,t:String;
  i,j:Integer;
  procedure QSort(left,right:Integer);
  begin
    if (left<right) then begin
      s:=strs[(left+right) Shr 1];
      i:=left-1;
      j:=right+1;
      while True do begin

        repeat
          Inc(i);
        until (strs[i]>=s);

        repeat
          Dec(j);
        until (strs[j]<=s);

        if (i>=j) then
          break;

        t:=strs[i];
        strs[i]:=strs[j];
        strs[j]:=t;
      end;
      QSort(left,i-1);
      QSort(j+1,right);
    end;
  end;
begin
  QSort(0,strs.Count-1);
end;

//~QuickSort֐(񃊃Xg)
procedure SUT_QsortStringsDown(strs:TStrings);
var
  s,t:String;
  i,j:Integer;
  procedure QSort(left,right:Integer);
  begin
    if (left<right) then begin
      s:=strs[(left+right) Shr 1];
      i:=left-1;
      j:=right+1;
      while True do begin

        repeat
          Inc(i);
        until (strs[i]<=s);

        repeat
          Dec(j);
        until (strs[j]>=s);

        if (i>=j) then
          break;

        t:=strs[i];
        strs[i]:=strs[j];
        strs[j]:=t;
      end;
      QSort(left,i-1);
      QSort(j+1,right);
    end;
  end;
begin
  QSort(0,strs.Count-1);
end;



//tH[ʒu̓ǂݏ
procedure SUT_SaveFormPos(iniName:String; section:String; frm:TForm);
var
  ini:TIniFile;
  wp:TWindowPlacement;
begin
  ini:=TIniFile.Create(iniName);


  ini.WriteBool(section,'Maximized',frm.WindowState = wsMaximized);

  if frm.WindowState = wsMaximized then begin
    wp.length:=sizeof(wp);
    GetWindowPlacement(frm.Handle,@wp);
    ini.WriteInteger(section,'Top',wp.rcNormalPosition.Top);
    ini.WriteInteger(section,'Left',wp.rcNormalPosition.Left);
    ini.WriteInteger(section,'Width',wp.rcNormalPosition.Right - wp.rcNormalPosition.Left);
    ini.WriteInteger(section,'Height',wp.rcNormalPosition.Bottom - wp.rcNormalPosition.Top);
  end else begin
    ini.WriteInteger(section,'Top',frm.Top);
    ini.WriteInteger(section,'Left',frm.Left);
    ini.WriteInteger(section,'Width',frm.Width);
    ini.WriteInteger(section,'Height',frm.Height);
  end;

  ini.Free;
end;

procedure SUT_LoadFormPos(iniName:String; section:String; frm:TForm);
var
  ini:TIniFile;
begin
  ini:=TIniFile.Create(iniName);

  frm.Top:=ini.ReadInteger(section,'Top',frm.Top);
  frm.Left:=ini.ReadInteger(section,'Left',frm.Left);
  frm.Width:=ini.ReadInteger(section,'Width',frm.Width);
  frm.Height:=ini.ReadInteger(section,'Height',frm.Height);

  if ini.ReadBool(section,'Maximized',frm.WindowState = wsMaximized) then
    frm.WindowState := wsMaximized;

  ini.Free;
end;


//tH[̂߂荞݂𒼂
procedure SUT_RegulateFormPos(frm:TForm);
begin
  with frm do begin
    if Left > (Screen.Width-Width) then
      Left:= Screen.Width-Width
    else if Left < 0 then
      Left:=0;
    if Top  > (Screen.Height-Height) then
      Top := Screen.Height-Height
    else if Top < 0 then
      Top:=0;
  end;
end;


function  SUT_ININame:string; //ftHgINIt@C̖O
begin
  result:=ChangeFileExt(Application.ExeName,'.ini');
end;

function  SUT_AppPath:String; //Av̒uĂfBNg
begin
  result:=ExtractFilePath(Application.ExeName);
end;

function  SUT_ImgPath:String; //摜t@C̒uĂftHg̃fBNg
begin
  result:=ExtractFilePath(Application.ExeName) + 'bmp\';
end;


procedure DPF(x:String);
begin
{$IFNDEF NDPF}
  MessageDlg(x,mtInformation,[mbOK],0);
{$ENDIF}
end;

procedure DPF2(x:String; mt:TMsgDlgType);
begin
{$IFNDEF NDPF}
  MessageDlg(x,mt,[mbOK],0);
{$ENDIF}
end;

procedure NPF(x:String);
begin
  MessageDlg(x,mtInformation,[mbOK],0);
end;

procedure NPF2(x:String; mt:TMsgDlgType);
begin
  case mt of
    mtWarning:MessageBeep(MB_ICONEXCLAMATION);
    mtInformation:MessageBeep(MB_ICONASTERISK);
    mtError:MessageBeep(MB_ICONEXCLAMATION);
    mtConfirmation:MessageBeep(MB_ICONQUESTION);
  end;
  MessageDlg(x,mt,[mbOK],0);
end;

procedure DP_Start(fname:String);
begin
  AssignFile(F,fname);
  ReWrite(F);
end;

procedure DP_End;
begin
  Close(F);
end;

procedure DPS(x:String);
begin
  Writeln(F,x);
end;

var
  Tmp:Comp;
  TmpH:DWord;
  TmpL:DWord;

procedure _GetCLK;
begin
  asm
    db 00001111b;
    db 00110001b;
    mov TmpH,edx;
    mov TmpL,eax;
  end;
end;

function GetCLK:Comp;
begin
  {$IFNDEF NOT_INTEL}
  _GetCLK;

  Tmp:= TmpH;
  Tmp:=Tmp * 4294967296.00;
  Tmp:=Tmp+TmpL;
  result:=Tmp;
  {$ELSE}
  result:=0;
  {$ENDIF}
end;


////////////////////////
// TDynArray
////////////////////////
constructor TDynIntArray.Create(nElem:Integer);
begin
  inherited Create;

  GetMem(FContent,Sizeof(integer)*nElem);
end;

destructor TDynIntArray.Destroy;
begin
  FreeMem(FContent);
  inherited;
end;

function TDynIntArray.getItem(idx:Integer):Integer;
var
  p:PInteger;
begin
  p:=FContent;
  Inc(p,idx);
  result:=p^
end;

procedure TDynIntArray.setItem(idx,v:Integer);
var
  p:PInteger;
begin
  p:=FContent;
  Inc(p,idx);
  p^:=v;
end;


////////////////////////
// TDynArray2D
////////////////////////
constructor TDynIntArray2D.Create(nElem1,nElem2:Integer);
var
  s:Integer;
begin
  inherited Create;

  //nElem2AShiftFactor߂
  s:=1;
  FShiftFactor:=0;
  while s < nElem2 do begin
    s := s Shl 1;
    Inc(FShiftFactor);
  end;

  GetMem(FContent,Sizeof(integer)*nElem1 * s);
end;

destructor TDynIntArray2D.Destroy;
begin
  FreeMem(FContent);
  inherited;
end;

function TDynIntArray2D.getItem(idx1,idx2:Integer):Integer;
var
  p:PInteger;
begin
  p:=FContent;
  Inc(p,idx1 Shl FShiftFactor);
  Inc(p,idx2);
  result:=p^
end;

procedure TDynIntArray2D.setItem(idx1,idx2,v:Integer);
var
  p:PInteger;
begin
  p:=FContent;
  Inc(p,idx1 Shl FShiftFactor);
  Inc(p,idx2);
  p^:=v;
end;


end.
