//V[eBOQ[EJ[l

unit SHKernel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DDSD, dddd, ddddut, s_util,ddraw, dinput, ddidex,
  defs, Primitives;


type

TMoverList = class;
TScheduler = class;

TMoveCallBack = procedure(t:Integer) of object;

//̂̊NX
TMover = class(TObject)
  private
    FID:Integer;        //MoverID
    FShootT:Array[0..7] of Integer;    //Oe(8Xbg)
    MemIdx:Integer;     //ubN̔ԍ
  protected
    birthT:Integer;     //ꂽ
    ageT:Integer;       //Ă̎
    nTouchRect:Integer;     //LȏՓ˔p`̐

    FAttr:TMoverAttr;     //ړ̂ƂẴJeS(PʁEʁEQEX[)
    FSubAttr:TMoverOption;//IvV
    FTouchRect:Array[0..7] of TRect;    //蔻(ő8)
    FOWner:TMoverList;  //IuU[o[ƂȂTMoverList̃CX^X
    FDead:Boolean;      //ɃtO
    FDamage:Integer;    //Ƃ̍U

    ShootCount:Array[0..7] of Integer; //e

    function CanShootRandom(t:Integer):Boolean; //px t/60 ̊mŁAeǂ̔
    function CanShootConst(slot,t:Integer):Boolean;  // tԊuŁAeǂ̔
    class function NewInstance:TObject; override;
    procedure FreeInstance; override;
  public
    X,Y:Integer;        //W
    HP:Integer;         //qbg|Cg
    Parent:TMover;      //̋@̂̏ґ
    constructor Create(owner:TMoverList);
    procedure Move(t:Integer); virtual;
    procedure Die; virtual;
    procedure SendMessage(target:TMover; msg:Word; param:Pointer); virtual; //bZ[W𑗂
    procedure CatchMessage(msg:Word; param:Pointer); virtual;  //bZ[W󂯂
    function CheckTouch(Target:TMover):Boolean; virtual; //蔻
    procedure OnCrush(Target:TMover); virtual; //Փˎ̃Cxg
    procedure OnDie; virtual;     //񂾂Ƃ̃Cxg
    procedure OnDamaged(dmg:Integer); virtual; //_[WHƂ̃Cxg
    procedure OnPaint; virtual;   //JX^`惋[`
    property Attr:TMoverAttr read FAttr;
    property SubAttr:TMoverOption read FSubAttr write FSubAttr;
    property Damage:Integer read FDamage;
    property ID:Integer read FID;
end;


//ԑJڂ̊Ǘ@\Mover
TTransMover = class(TMover)
  protected
    FState:Integer;      //
    StateChangeT:Integer; //ԑJڂN
    StateT:Integer;     //݂̏ԂɈڂĂ̎
    procedure SetState(v:Integer);
  public
    constructor Create(owner:TMoverList);
    procedure Move(t:Integer); override; 
    property State:Integer read FState write setState;
end;


//Azzx[X́AT[tFXǂ݂ / opNX
TSurfaceContainer = class
  private
    BMPNames:TStrings;
    function getSurface(key:String):TDDDDSurface; virtual;
  public
    property Items[key:String]:TDDDDSurface read getSurface; default;
    constructor Create;
    destructor Destroy;
end;

//eNX`ǗNX
TTextureContainer = class(TSurfaceContainer)
  private
    function getTexture(key:String):TDDDDTexture;
  public
    property Items[key:String]:TDDDDtexture read getTexture; default;
end;


//LN^̊ǗIuWFNg
TMoverList = class(TList)
  private
    FreeSP:Integer;                       //󂫃XvCgX^bN|C^
    FreeSpr:Array[0..MAX_SPR] of Integer; //󂫃XvCgX^bN
    FTick:Integer;      //Q[Jn牽t[oH
    FRestTime:Integer;  //c莞(1/60bP)
    FNCalled:Integer;   //Move\bhĂ΂ꂽ?
    FScore:Integer;     //XRA
    FMaxScore:Integer;  //uԍő哾_
    FRestHero:Integer;  //c@
    FgameState:TGameState; //Q[̏
    FFlash:Boolean;     //̉ʏł́Aʂ点邩H
    FFlashCol:DWord;    //ʂ点Ƃ̐F
    procedure SetScore(v:Integer);
    function getMover(idx:Integer):TMover;
    //procedure setMover(idx:Integer; v:TMover);
  public
    Surfaces:TSurfaceContainer;
    Textures:TTextureContainer;
    LogoSurf:TDDDDSurface;
    //ImgSurf:TDDDDSurface;
    //BossSurf:TDDDDSurface;
    //DemoSurf:TDDDDSurface;
    //LitSurf:TDDDDSurface;

    MoveCLK:Comp;           //SIuWFNgMove()sɂ
    BltCLK:Comp;            //Spr.Updateɂ
    TouchCLK:Comp;          //蔻ɂ
    NCrush,NMaxCrush:Integer;  //`̈܂Ō / 茟

    Rend:TPrimitiveRenderer; //|S
    Spr:TDDDDSprite;          //XvCgZbg
    Scheduler:TScheduler;
    HeroPos:TPoint;         //ƔۂǁAq[[ʒu
    TimeStop:Boolean;       //c莞Ԃ炳Ȃ

    HeroPower:Integer;      //q[[̃GlM[Q[W  cgp
    FrameInfo:TFrameInfo;   //̃t[łǂȑ삪N@cgp

    MoveCallBack:TMoveCallBack; //Move葱Ă΂ꂽ̃R[obN

    constructor Create;
    destructor Destroy; override;
    procedure Move(t:Integer);  //1.01/60bB
    property Movers[idx:Integer]:TMover read getMover;
    procedure Setup;
    procedure Restore;
    procedure HeroDie;                  //@ꂽ
    procedure GameStart;                //Q[Jn
    procedure GameEnd;
    procedure TitleStart;
    function  NewSprite:Integer;        //󂫃XvCgԍ𓾂
    procedure FreeSprite(idx:Integer);  //XvCgԋp
    procedure Flash(col:TColor);        //ʂtbV
    property Tick:Integer     read FTick;
    property NCalled:Integer  read FNCalled;
    property MaxScore:Integer read FmaxScore;
    property Score:Integer    read FScore write setScore;
    property RestHero:Integer read FRestHero;
    property GameState:TGameState read FGameState;
    property RestTime:Integer read FRestTime;       //c^C

    property NSprites:Integer read FreeSP;  //gp̃XvCg
end;

TScheduler = class(TMover)
  private
    Fate:TStrings;  //t@Cǂݍޔzuf[^
    iFate:Integer;  //zuf[^̂ǂ𐶐ׂ
  public
    constructor Create(owner:TMoverList);
    destructor Destroy; override;
    procedure Spawn;  //XPW[ɏ]āAGL𐶐
    procedure CatchMessage(msg:Word; param:Pointer); override;  //bZ[W󂯂
end;



implementation

uses  group,demo,hero;


/////////////////////////////////////////
// TSurfaceContainer
/////////////////////////////////////////

constructor TSurfaceContainer.Create;
begin
  BMPNames:=TStringList.Create;
end;

destructor TSurfaceContainer.Destroy;
begin
  BMPNames.Free;
end;

function TSurfaceContainer.getSurface(key:String):TDDDDSurface;
var
  i,idx:Integer;
  bih:TBITMAPINFOHEADER;
  surf:TDDDDSurface;
  fname:String;
begin

  key:=AnsiUpperCase(key);

  //L[gČ
  idx:=-1;
  for i:=0 to BMPNames.Count-1 do begin
    if BMPNames[i] = key then begin
      idx:=i;
      break;
    end;
  end;

  if idx=-1 then begin
    //V
    fname:=IMGPATH + key;
    {$IFDEF USE_QDA}
    ReadBMPHeaderFromQDA(PATH+'shooter.qda',ExtractFileName(fname),bih);
    {$ELSE}
    ReadBMPHeader(fname,bih);
    {$ENDIF}

    if (key = 'logo.bmp') then
      surf:=TDDDDSurface.CreateOnSystemMemory(QD,bih.biWidth,bih.biHeight,0)
    else{ if USE_HAL then
      surf:=TDDDDSurface.CreateOnVideoMemory(QD,bih.biWidth,bih.biHeight,0)
    else}
      surf:=TDDDDSurface.Create(QD,bih.biWidth,bih.biHeight,0);


    {$IFDEF USE_QDA}
    surf.LoadFromQDA(PATH+'shooter.qda',ExtractFileName(fname));
    {$ELSE}
    surf.LoadBMP(fname);
    {$ENDIF}

    BMPNames.AddObject(key,surf);
    result:=surf;

    DDDD_PutDebugMessage('[h ' + fname);

  end else begin
    result:=Pointer(BMPNames.Objects[idx]);
  end;
end;

/////////////////////////////////////////
// TTextureContainer
/////////////////////////////////////////
function TTextureContainer.getTexture(key:String):TDDDDTexture;
var
  i,idx:Integer;
  tex:TDDDDTexture;
  fname:String;
  bih:TBitmapInfoHeader;
begin

  key:=AnsiUpperCase(key);

  //L[gČ
  idx:=-1;
  for i:=0 to BMPNames.Count-1 do begin
    if BMPNames[i] = key then begin
      idx:=i;
      break;
    end;
  end;

  if idx=-1 then begin
    //V
    fname:=IMGPATH + key;

    {$IFDEF USE_QDA}
    ReadBMPHeaderFromQDA(PATH+'shooter.qda',ExtractFileName(fname),bih);
    {$ELSE}
    ReadBMPHeader(fname,bih);
    {$ENDIF}

    tex:=TDDDDTexture.Create(QD, bih.biWidth, bih.biHeight, 0, '');

    {$IFDEF USE_QDA}
    tex.LoadFromQDA(PATH+'shooter.qda',ExtractFileName(fname));
    {$ELSE}
    tex.LoadBMP(fname);
    {$ENDIF}

    BMPNames.AddObject(key,tex);
    result:=tex;

    DDDD_PutDebugMessage('[h ' + fname);
  end else begin
    result:=Pointer(BMPNames.Objects[idx]);
  end;
end;



/////////////////////////////////////////
// TMover
/////////////////////////////////////////

constructor TMover.Create(owner:TMoverList);
var
  i:Integer;
begin
  inherited Create;

  FOwner:=owner;
  birthT:=FOwner.Tick;
  FSubAttr:=[];

  FDead:=False;

  //ID̕t^
  FID:=NewID;
  Inc(NewID);

  for i:=0 to 7 do
    ShootCount[i]:=0;

end;

//TMover̃m
class function TMover.NewInstance:TObject;
var
  idx:Integer;
begin
  idx:=NewMoverMem;

  result:=InitInstance(@MemoryPool[idx,1]);
  TMover(result).MemIdx:=idx;

  //DDDD_PutDebugMessage(IntToStr(InstanceSize));
  //DDDD_PutDebugMessage(IntToStr(idx));
end;

//̉
procedure TMover.FreeInstance;
begin
  FreeMoverMem(MemIdx);
end;


//\bh
procedure TMover.Move(t:Integer);
begin
  //قƂǉȂB
  Inc(ageT,t);
end;

//
procedure TMover.Die;
begin
  FDead:=True;
  OnDie;
end;

//_[WH炤
procedure TMover.OnDamaged(dmg:Integer);
begin
end;

//蔻
function TMover.CheckTouch(Target:TMover):Boolean;
var
  i,j:Integer;
  a,b:TRect;
begin
  result:=False;

  for i:=0 to NTouchRect-1 do begin
    a:=FTouchRect[i];
    Inc(a.left,X);
    Inc(a.Top,Y);
    Inc(a.right,X);
    Inc(a.Bottom,Y);
    for j:=0 to Target.nTouchRect-1 do begin
      b:=Target.FTouchRect[j];
      with Target do begin
        Inc(b.left,X);
        Inc(b.Top,Y);
        Inc(b.right,X);
        Inc(b.bottom,Y);
      end;

      if (a.right > b.left) And (a.left < b.right) And (a.bottom > b.top) And (a.top < b.bottom) then begin
      //if IntersectRect(dummy,a,b) then begin
        result:=True;
        Exit;
      end;

    end;
  end;
end;

//Փˎ̓
procedure TMover.OnCrush(Target:TMover);
begin
  //ɂȂɂȂ
end;

//bZ[W𑡂
procedure TMover.SendMessage(Target:TMover; msg:Word; param:Pointer);
begin
  Target.CatchMessage(msg,param);
end;

//bZ[W󂯂
procedure TMover.CatchMessage(msg:Word; param:Pointer);
begin
  //ftHgł͉Ȃ
end;


//񂾂Ƃ̃Cxg
procedure TMover.OnDie;
begin
  if Parent <> Nil then
    SendMessage(Parent,MSG_IAMDIE, Nil);
end;

//JX^`惋[`
procedure TMover.OnPaint;
begin
  //ftHgł͉Ȃ
end;


//px tŁAe?
function TMover.CanShootRandom(t:Integer):Boolean;
begin
  result := Random(60) < t;
end;

//60t[t̃y[XŁAe
function TMover.CanShootConst(slot,t:Integer):Boolean;
var
  interval:Integer;
begin
  if t = 0 then begin
    result:=False;
    Exit;
  end;

  interval:=60 div t;

  if FShootT[slot] <= AgeT - interval then begin
    result:=True;
    FShootT[slot]:=AgeT;
    Inc(ShootCount[slot]);
  end else
    result:=False;
end;


/////////////////////////////////////////
// TTransMover
/////////////////////////////////////////

constructor TTransMover.Create(owner:TMoverList);
begin
  inherited;
  StateT:=0;
  StateChangeT:=0;
  FState:=0;
end;

procedure TTransMover.SetState(v:Integer);
begin
  FState:=v;
  StateChangeT:=AgeT;
  StateT:=0;
end;


procedure TTransMover.Move(t:Integer);
begin
  inherited;
  
  Inc(StateT,t);
end;




/////////////////////////////////////////
// TMoverList
/////////////////////////////////////////

constructor TMoverList.Create;
var
  i:Integer;
begin
  inherited Create;

  FTick:=0;
  FScore:=0;
  FMaxScore:=0;
  FGameState:=gsTitle;
  TimeStop:=False;
  FRestTime:=GAMETIME;

  //defsŐ錾ĂAMoverp}l[W̐ݒ
  InitMemoryStack;

  //󂫃XvCgX^bŇ`
  For i:=0 to MAX_SPR do
    FreeSpr[i]:=i;
  FreeSP:=0;

  //XvCgIuWFNg̐
  Spr:=TDDDDSprite.Create(NUM_SPR,NUM_SHAPE);
  Spr.ZMax:=Z_MAX;  //0-Z_MAX܂ZlLɂ

  //_̐
  Rend:=TPrimitiveRenderer.Create(QD,NUM_PRIMITIVES,NUM_TEXTUREPATTERNS);
  Rend.ZMax:=Z_MAX;

  //T[tFXCeNX`ǗIuWFNg̐
  Surfaces:=TSurfaceContainer.Create;
  Textures:=TTextureContainer.Create;

  //\[Xǂݍ
  Setup;

end;


destructor TMoverList.Destroy;
var
  i:Integer;
begin
  For i:=0 to Count-1 do begin
    if Movers[i]<>Nil then
      Movers[i].Free;
  end;

  Spr.Free;
  Rend.Free;

  inherited Destroy;
end;

//\[X̓ǂݍ
procedure TMoverList.Setup;
var
  i,j:Integer;
  pLine:PByte;
  pPix:PWord;
  ddsd:DDSurfaceDesc2;
  x,y:Integer;
  dmy:Integer;

  nShapes:Integer;  //VFCvԂ܂œo^H
  nPatterns:Integer; //eNX`p^[o^H

  //x,yWɎAsx,syTCỸLN^̘AȂ́ACfNXĩp[c
  //W16hbgPʂƂB(gp)
  function PosToRect(x,y, sx,sy, i:Integer):TRect;
  begin
    with result do begin
      left:=x*16 + sx * i;
      top:=y*16;
      right:=x*16 + sx * (i+1);
      bottom:=y*16 + sy;
    end;
  end;

  //x,yWɎAsizesl̃p^[̘AȂAstartn܂p^[ɃATC
  procedure PosToShape(var start:Integer; x,y:Integer; sizes:Array of Integer; bmp:String);
  var
    i:Integer;
    l,t:Integer;
  begin
    l:=x*16;
    t:=y*16;

    start:=nShapes;

    For i:=Low(sizes) to High(sizes) do begin
      Spr.SetShape(start + i,Surfaces[bmp], Rect(l,t,l+sizes[i],t+sizes[i]));
      l:=l+sizes[i];
    end;

    Inc(nShapes,High(sizes)+1);
  end;

  //x,yWɎATCYsizes̃p^[̘AȂAstartn܂p^[ɃATC
  procedure PosToShape2(var start:Integer; x,y:Integer; sizes:Array of Integer; bmp:STring);
  var
    i:Integer;
    l,t:Integer;
  begin
    l:=x*16;
    t:=y*16;
    start:=nShapes;
    For i:=Low(sizes) to High(sizes) div 2 do begin
      Spr.SetShape(start + i,Surfaces[bmp], Rect(l,t,l+sizes[i*2],t+sizes[i*2+1]));
      l:=l+sizes[i*2];
    end;
    Inc(nShapes,(High(sizes)+1) div 2);
  end;


  //x,yWɎATCYsizes̃p^[̘AȂAstartn܂p^[ɃATC
  procedure PosToPattern2(var start:Integer; x,y:Integer; sizes:Array of Integer; bmp:STring);
  var
    i:Integer;
    l,t:Integer;
  begin
    l:=x*16;
    t:=y*16;
    start:=nPatterns;
    For i:=Low(sizes) to High(sizes) div 2 do begin
      Rend.SetPattern(start + i,Textures[bmp], Rect(l,t,l+sizes[i*2],t+sizes[i*2+1]));
      l:=l+sizes[i*2];
    end;
    Inc(nPatterns,(High(sizes)+1) div 2);
  end;

begin

  nShapes:=0;
  nPatterns:=0;

  Screen.Cursor:=crHourglass;

  //T[tFX̍쐬

  //fobOpAVRAMɃT[tFXăEBhE[hłK
  {
  ImgSurf:=TDDDDSurface.CreateOnVideoMemory(QD,640,480,0);
  ImgSurf.LoadBMP(IMGPATH+'images.bmp');
  BossSurf:=TDDDDSurface.CreateOnVideoMemory(QD,640,480,0);
  BossSurf.LoadBMP(IMGPATH+'boss.bmp');
  DemoSurf:=TDDDDSurface.CreateOnVideoMemory(QD,640,480,0);
  DemoSurf.LoadBMP(IMGPATH+'democg.bmp');
  LogoSurf:=TDDDDSurface.CreateOnSystemMemory(QD,384,80,0);
  LogoSurf.LoadBMP(IMGPATH+'logo.bmp');
  LitSurf:=TDDDDSurface.CreateOnVideoMemory(QD,640,480,0);
  LitSurf.LoadBMP(IMGPATH+'lit.bmp');
  }
  
  //QDAŁA[X
  {
  ImgSurf:=TDDDDSurface.Create(QD,640,480,0);
  ImgSurf.LoadFromQDA(PATH+'shooter.qda','images.bmp');
  BossSurf:=TDDDDSurface.Create(QD,640,480,0);
  BossSurf.LoadFromQDA(PATH+'shooter.qda','boss.bmp');
  DemoSurf:=TDDDDSurface.Create(QD,640,480,0);
  DemoSurf.LoadFromQDA(PATH+'shooter.qda','democg.bmp');
  LogoSurf:=TDDDDSurface.CreateOnSystemMemory(QD,384,80,0);
  LogoSurf.LoadFromQDA(PATH+'shooter.qda','logo.bmp');
  LitSurf:=TDDDDSurface.Create(QD,640,480,0);
  LitSurf.LoadFromQDA(PATH+'shooter.qda','lit.bmp');
  Screen.Cursor:=crDefault;
  }


  ///////////////////////eNX`
  PosToPattern2(P_BALL,    $00,$00, [32,32], 'TexBall.bmp');    //{[
  PosToPattern2(P_THUNDER, $00,$00, [16,64], 'Thunder.bmp');    //
  PosToPattern2(P_RING,    $00,$00, [32,32], 'Ring.bmp');       //ep
  PosToPattern2(P_RINGL,   $00,$00, [128,128], 'RingL.bmp');    //ׂ
  PosToPattern2(P_PILLAR,  $04,$00, [32,32, 32,32, 32,32, 32,32], 'sparkS1.bmp');   //Β

  PosToPattern2(P_B1,      $00,$06, [48,48, 48,48, 48,48, 48,48], 'sparkS1.bmp');   //
  PosToPattern2(P_B2,      $00,$00, [64,64, 64,64, 64,64, 64,64], 'sparkL1.bmp');   //F
  PosToPattern2(P_B4,      $00,$04, [64,64, 64,64, 64,64, 64,64], 'sparkL1.bmp');   //sN̔

  PosToPattern2(P_M1SMOKE, $00,$09, [32,32, 32,32, 32,32, 32,32], 'SparkS1.bmp');   //
  PosToPattern2(P_FLARE1,  $00,$00, [128,128], 'LensFlare1.bmp');                   //YtA1
  PosToPattern2(P_FLARE2,  $00,$00, [64,64], 'LensFlare2.bmp');                     //YtA2
  PosToPattern2(P_SHOCK1,  $00,$00, [128,128], 'Shock1.bmp');                       //MUMUՌg1
  PosToPattern2(P_RIBBON,  $00,$00, [32,32], 'Ribbon.bmp');                         //{

  PosToPattern2(P_HADOU,   $00,$00, [64,80, 64,80, 64,80], 'hadou.bmp'); //gC
  PosToPattern2(P_HADOU,   $00,$05, [64,80, 64,80, 64,80], 'hadou.bmp'); //gC
  Dec(P_HADOU,3);

  PosToPattern2(P_BOSS2,   $00,$00, [256,256], 'boss2.bmp'); //{X2
  PosToPattern2(P_SABRE,   $00,$00, [ 28,198], 'sabre.bmp'); //{X2̓

  PosToPattern2(P_GRADBALL,$00,$00, [ 16, 16], 'gradball.bmp'); //Of̊ɂ{[

  PosToPattern2(P_TAMA1  , $00,$0B, [16,32], 'sparkS1.bmp');  //m[}Vbg
  PosToPattern2(dmy  , $03,$0B, [32,32], 'sparkS1.bmp');
  PosToPattern2(dmy  , $01,$0B, [32,32], 'sparkS1.bmp');
  PosToPattern2(dmy  , $01,$0D, [32,32], 'sparkS1.bmp');
  PosToPattern2(dmy  , $03,$0D, [32,32], 'sparkS1.bmp');


  For i:=0 to 5 do begin
    For j:=0 to 7 do begin
      PosToPattern2(P_FONT,$02 * j,$02 * i, [24,24], 'font.bmp'); //tHg
    end;
  end;
  Dec(P_FONT,48-1);

  For i:=0 to 5 do begin
    For j:=0 to 7 do begin
      PosToPattern2(P_FONT2,$01 * j,$01 * i, [16,16], 'font2.bmp'); //tHg()
    end;
  end;
  Dec(P_FONT2,48-1);



  //q[[
  PosToShape(S_HERO, $00,$00,[64,64,64,64, 64,64,64,64, 64,64], 'hero.bmp');
  Inc(S_HERO,2);


  //{X1
  PosToShape2(S_BOSS1 , $00,$00, [256,256], 'boss.bmp'); //{
  PosToShape2(S_BOSS1L, $10,$00, [ 96,288], 'boss.bmp'); //̕
  PosToShape2(S_BOSS1R, $16,$00, [ 96,288], 'boss.bmp'); //
  PosToShape2(S_BOSS1C, $00,$10, [112,112], 'boss.bmp'); //Jo[


  //UR1
  PosToShape(S_ZAKO1, $00,$00, [64,64,64,64, 64,64,64,64], 'zako1.bmp');

  //UR2
  PosToShape(S_ZAKO2, $00,$00, [128], 'zako2.bmp');

  //UR3
  PosToShape(S_ZAKO3, $00,$00, [96], 'zako3.bmp');

  //UR4
  PosToShape(S_ZAKO4, $00,$00, [64,64,64,64, 64,64,64,64], 'zako4.bmp');

  //UR5
  PosToShape(S_ZAKO5, $00,$00, [48,48,48,48, 48,48,48,48], 'zako5.bmp');

  //UR6
  PosToShape(S_ZAKO6, $00,$00, [64,64,64,64], 'zako6.bmp');
  PosToShape(S_ZAKO6, $00,$04, [64,64,64,64], 'zako6.bmp');
  Dec(S_ZAKO6,4);

  //UR7
  PosToShape(S_ZAKO7, $00,$00,[128], 'zako7.bmp');

  //UR8
  PosToShape(S_ZAKO8, $00,$00,[128], 'zako8.bmp');

  //UR9
  PosToShape(S_ZAKO9, $00,$00,[128], 'zako9.bmp');

  



  //ACeLA
  //PosToShape(S_CARRIER, $20,$1F, [80], 'images.bmp');

  //~TC1
  PosToShape2(S_MISSILE1,$08,$00,[16,48], 'weapon1.bmp');



  //e

  PosToShape(S_RAILGUN, $01,$03, [16,16,16] ,'weapon1.bmp');  //[K
  PosToShape(S_ETAMA1, $00,$00, [16,16,16,16], 'weapon1.bmp'); //Ge1
  PosToShape(S_ETAMA2, $04,$00, [16,16], 'weapon1.bmp');  //Ge2



  //p[ACe
  {
  PosToShape2(S_POWER  , $18,$12, [32,32, 32,32, 48,32], 'democg.bmp');
  PosToShape2(dmy  , $18,$14, [32,32, 32,32, 48,32], 'democg.bmp');
  PosToShape2(dmy  , $18,$16, [32,32, 32,32, 48,32], 'democg.bmp');
  PosToShape2(dmy  , $18,$18, [32,32, 32,32, 48,32], 'democg.bmp');
  }
  

  ///////////fp

  //^CgS
  PosToShape2(S_LOGO, $00,$00, [384,80], 'Logo.bmp');
  LogoSurf:=Surfaces['logo.bmp'];

  //^CgS̃}XN쐬
  if not LogoSurf.IsLost then begin
    LogoSurf.Lock(ddsd);
    pLine:=ddsd.lpSurface;
    For y:=0 to MAX_LOGOY do begin
      pPix:=Pointer(pLine);
      For x:=0 to MAX_LOGOX do begin
        if pPix^ = 0 then
          LogoMask[y,x]:=False
        else
          LogoMask[y,x]:=True;
        Inc(pPix);
      end;
      Inc(pLine,ddsd.lPitch);
    end;
    LogoSurf.Unlock;
  end;

  //SANDMAN presents!!
  PosToShape2(S_CREDIT, $00,$00, [304,16], 'strings.bmp');


  //RtBO[V֌W̕
  PosToShape2(S_OPR,     $00+0*$14,$01, [160,16], 'strings.bmp');   //OPERATION START
  PosToShape2(dmy,       $00+1*$14,$01, [160,16], 'strings.bmp');   //OPERATION START

  PosToShape2(S_RANKING, $14,$05, [96,16],  'strings.bmp');   //RANKING
  PosToShape2(dmy,       $14,$06, [96,16],  'strings.bmp');   //RANKING

  PosToShape2(S_RANK  ,  $00+0*$14,$02, [64,16],  'strings.bmp');   //RANK
  PosToShape2(dmy,       $00+1*$14,$02, [64,16],  'strings.bmp');   //RANK
  PosToShape2(dmy,       $04+0*$14,$02, [48,16],  'strings.bmp');
  PosToShape2(dmy,       $04+1*$14,$02, [48,16],  'strings.bmp');
  PosToShape2(dmy,       $07+0*$14,$02, [80,16],  'strings.bmp');
  PosToShape2(dmy,       $07+1*$14,$02, [80,16],  'strings.bmp');
  PosToShape2(dmy,       $0C+0*$14,$02, [96,16],  'strings.bmp');
  PosToShape2(dmy,       $0C+1*$14,$02, [96,16],  'strings.bmp');

  PosToShape2(S_INPUT  ,  $00+0*$14,$03,[112,16], 'strings.bmp'); //0NPUT
  PosToShape2(dmy,        $00+1*$14,$03,[112,16], 'strings.bmp'); //1NPUT
  PosToShape2(dmy,        $07+0*$14,$03,[80,16],  'strings.bmp');
  PosToShape2(dmy,        $07+1*$14,$03,[80,16],  'strings.bmp');
  PosToShape2(dmy,        $0C+0*$14,$03,[80,16],  'strings.bmp');
  PosToShape2(dmy,        $0C+1*$14,$03,[80,16],  'strings.bmp');

  PosToShape2(S_FORCE,    $00+0*$14,$04,[64,16],  'strings.bmp');  //FORCE
  PosToShape2(dmy,        $00+1*$14,$04,[64,16],  'strings.bmp');  //FORCE
  PosToShape2(dmy,        $04+0*$14,$04,[80,16],  'strings.bmp');
  PosToShape2(dmy,        $04+1*$14,$04,[80,16],  'strings.bmp');
  PosToShape2(dmy,        $09+0*$14,$04,[80,16],  'strings.bmp');
  PosToShape2(dmy,        $09+1*$14,$04,[80,16],  'strings.bmp');


  //Q[I[o[̕
  PosToShape2(S_GAMEOVER, $00,$05, [320,64], 'strings.bmp');

  //Q[NA̕
  PosToShape2(S_GAMECLEAR, $14,$07, [272,64], 'strings.bmp');

  //SŃ{[iX(gp)
  PosToShape2(S_GGENO,$00,$09,[96,32], 'strings.bmp');
  PosToShape2(S_G90,$06,$09,[96,32], 'strings.bmp');
  PosToShape2(S_G80,$0C,$09,[96,32], 'strings.bmp');

  //CpNg{[iX(gp)
  PosToShape2(S_I16,$00,$0B, [64,32], 'strings.bmp');
  PosToShape2(S_I8 ,$04,$0B, [64,32], 'strings.bmp');
  PosToShape2(S_I4 ,$08,$0B, [64,32], 'strings.bmp');
  PosToShape2(S_I2 ,$0C,$0B, [64,32], 'strings.bmp');


  //A{[iX
  PosToShape2(S_MULTI  ,$14,$0D, [32,16,32,16,32,16,32,16, 32,16,32,16,32,16,32,16, 32,16],'strings.bmp');
  PosToShape2(dmy,      $14,$0E, [32,16,32,16,32,16,32,16, 32,16,32,16,32,16,32,16, 32,16],'strings.bmp');


  //XRA
  PosToShape2(S_SCORE,$0C,$0D, [80,32],'strings.bmp');
  PosToShape2(S_SCORENUM,$00,$0D,[16,32,16,32,16,32,16,32, 16,32,16,32,16,32,16,32, 16,32,16,32,16,32,16,32],'strings.bmp');


  ///////////////////////


  //΂̕
  PosToShape(S_S2,$00,$03, [16,16,16,16, 16,16,16,16],'SparkS1.bmp');

  //΂̕()
  PosToShape(S_S3,$00,$02, [16,16,16,16, 16,16,16,16],'SparkS1.bmp');

  //Ή
  {
  For i:=0 to 3 do begin
    Spr.SetShape(S_FIRE1+i,'images.bmp',PosToRect($00,$10, 64,64, i));
  end;
  }

  //G4̃obNt@CA
  PosToShape2(S_BFZAKO4,$06,$04, [24,32, 24,32, 24,32, 24,32], 'SparkS1.bmp');

  //G5̃obNt@CA
  PosToShape2(S_BFZAKO5,$00,$04, [16,32, 16,32, 16,32, 16,32, 16,32, 16,32], 'SparkS1.bmp');

  //qbg}[N
  PosToShape(S_HIT1, $00,$00, [16,16,16,16], 'SparkS1.bmp');

  //3()
  PosToShape2(S_B3,$14,$05, [96,128, 96,128, 128,128], 'strings.bmp');

end;





//\[X̕
procedure TMoverList.Restore;
begin
  //ȂėǂȂ̂`

{
  if ImgSurf.IsLost then begin
    ImgSurf.Restore;
    ImgSurf.LoadBMP(IMGPATH+'images.bmp');
  end;

  if DemoSurf.IsLost then begin
    DemoSurf.Restore;
    DemoSurf.LoadBMP(IMGPATH+'democg.bmp');
  end;

  if BossSurf.IsLost then begin
    BossSurf.Restore;
    BossSurf.LoadBMP(IMGPATH+'democg.bmp');
  end;

  if LogoSurf.IsLost then begin
    LogoSurf.Restore;
    LogoSurf.LoadBMP(IMGPATH+'democg.bmp');
  end;
}
end;


function TMoverList.getMover(idx:Integer):TMover;
begin
  result:=Items[idx];
end;

{
procedure TMoverList.setMover(idx:Integer; v:TMover);
begin
  Items[idx]:=v;
end;
}

procedure TMoverList.Move(t:Integer);
var
  i,j:Integer;
  mi,mj:TMover;
  clk:Comp;
  nHB,nEB,nHero,nEnemy,nEraser:Integer; //eJeSɑIuWFNg̐
  MatHB,MatEB,MatHero,MatEnemy,MatEraser:Array[0..2047] of TMover;  //Ƃ肠ꂾႢł
begin

  //XLΗǂ悤ɁB
  Joy.OrScan([DI_JOY2,DI_JOY1,DI_KEYB]);

  {
  //vCȂAt[̓vCf[^ɏ]
  if (REPLAY And (FgameState = gsGame)) then
    t:=ReplayData[IReplay].step;
  }

  Inc(FNCalled);
  Inc(FTick,t);
  if not TimeStop then
    Dec(FRestTime,t);

  //TListExpands
  Expand;

  //( ̉
  i:=0;
  while i<Count do begin
    if Movers[i].FDead then begin
      Movers[i].Free;
      Delete(i);
      Continue;
    end;
    Inc(i);
  end;

  //S
  clk:=getCLK();
  for i:=0 to Count-1 do begin
    if not Movers[i].FDead then
      Movers[i].Move(t);
  end;
  moveCLK:=getCLK() - clk;

  clk:=getCLK();
  //蔻

  //eIuWFNgU蕪
  nHB:=0; nEB:=0; nHero:=0; nEnemy:=0;  nEraser:=0;
  For i:=0 to Count-1 do begin
    Case Movers[i].Attr of
      maHB: begin MatHB[nHB]:=Movers[i];  Inc(nHB); end;
      maEB: begin MatEB[nEB]:=Movers[i];  Inc(nEB); end;
      maHero: begin MatHero[nHero]:=Movers[i];  Inc(nHero); end;
      maEnemy: begin MatEnemy[nEnemy]:=Movers[i];  Inc(nEnemy); end;
      maEraser: begin MatEraser[nEraser]:=Movers[i];  Inc(nEraser); end;
    end;
  end;


  //܂łōsɁA蔻s
  NMaxCrush:=(nHB*nEnemy + nEB*nHero + nEnemy*nHero + nEB*nEraser) Shr 1;
  NCrush:=0;

  //q[[eƓG
  For i:=0 to nHB-1 do begin
    mi:=MatHB[i];
    For j:=0 to nEnemy-1 do begin
      mj:=MatEnemy[j];
      if mj.FDead then
        Continue;

      if mi.CheckTouch(mj) then begin
         Inc(nCrush);
         mi.OnCrush(mj);
         mj.OnCrush(mi);
      end;

      if mi.FDead then
        Break;
    end;
  end;

  //Geƃq[[
  For i:=0 to nEB-1 do begin
    mi:=MatEB[i];
    For j:=0 to nHero-1 do begin
      mj:=MatHero[j];
      if mj.FDead then
        Continue;

      if mi.CheckTouch(mj) then begin
         Inc(nCrush);
         mi.OnCrush(mj);
         mj.OnCrush(mi);
      end;

      if mi.FDead then
        Break;
    end;
  end;

  //q[[ƓG
  For i:=0 to nHero-1 do begin
    mi:=MatHero[i];
    For j:=0 to nEnemy-1 do begin
      mj:=MatEnemy[j];
      if mj.FDead then
        Continue;

      if mi.CheckTouch(mj) then begin
         Inc(nCrush);
         mi.OnCrush(mj);
         mj.OnCrush(mi);
      end;

      if mi.FDead then
        Break;
    end;
  end;

  //eƒe
  For i:=0 to nEraser-1 do begin
    mi:=MatEraser[i];
    For j:=0 to nEB-1 do begin
      mj:=MatEB[j];
      if mj.FDead then
        Continue;

      if mi.CheckTouch(mj) then begin
         Inc(nCrush);
         mi.OnCrush(mj);
         mj.OnCrush(mi);
      end;

      if mi.FDead then
        Break;
    end;
  end;


  touchCLK:=getCLK() - clk;

  clk:=getCLK();


  (*  `  *)
  asm
    finit;
  end;
  QD.D3DDevice.BeginScene;
  asm
    finit;
  end;

  //wi`pR[obN葱Ă
  if Assigned(MoveCallBack) then
    MoveCallBack(t);

  //tbV
  if FFlash then begin
    FFlash:=False;
    QD.BackBuffer.FillRect(Rect(0,0,640,480),FFlashCol);
  end;

  //XvCgE|S̕\
  Spr.Sort;
  Rend.BeginRender;
  For i:=0 to Z_MAX do begin
    Rend.RenderOneLayer(i);
    Spr.UpdateOneLayer(i);
  end;
  Rend.EndRender;

  asm
    finit;
  end;
  QD.D3DDevice.EndScene;
  asm
    finit;
  end;

  //JX^`
  For i:=0 to Count-1 do begin
    Movers[i].OnPaint;
  end;

  BltCLK:=getCLK()-clk;

  {
  //vCf[^̋L^
  if ((FgameState = gsGame) And (not REPLAY)) then begin
    FrameInfo.step:=t;
    ReplayData[IReplay]:=FrameInfo;
  end;

  Inc(IReplay);
  }

end;


function  TMoverList.NewSprite:Integer;        //󂫃XvCgԍԂ
begin
  result:=FreeSpr[FreeSP];  //X^bN̐擪n
  //gȒPɏ
  with Spr[result] do begin
    iAnim:=0;
    AddMode:=False;
    ResetSize();
  end;

  Inc(FreeSP);              //X^bN|C^𑝂₷

end;


procedure TMoverList.FreeSprite(idx:Integer);  //XvCgԋp
begin
  //X^bN̐擪߂B
  Dec(FreeSP);
  FreeSpr[FreeSP]:=idx;
end;


//߂nCXRA
procedure TMoverList.SetScore(v:Integer);
begin
  if GameState <> gsGame then
    Exit;

  if v < 0 then
    v:=0;

  if v > FMaxScore then
    FMaxScore:=v;
  FScore:=v;
end;

//cO
procedure TMoverList.HeroDie;
begin
  if RestTime < 0 then
    FRestHero:=0;

  //XeBbNOO
  if USE_FF And Assigned(FFx[FFX_DAMAGED]) then
    FFx[FFX_DAMAGED].Start(1,DIES_NODOWNLOAD);

  Dec(FRestHero);

  if FRestHero < 0 then begin
    //c@ȂȂQ[I[o[f쐬
    Add(TGameOver.Create(Self));
    FGameState:=gsGameOver;
  end else begin
    //c@ȂAo
    if GameState = gsGame then
      Add(THero.Create(Self));
  end;

end;

//Q[Jn
procedure TMoverList.GameStart;
var
  //FFX֘A̕ϐ
  axes:Array[0..1] of DWORD;          //GtFNgƊ֌Ŵ鎲
  direction:Array[0..1] of LongInt;   //U
  pd:DIPERIODIC;  //UɊւp[^
  ev:DIENVELOPE;  //U̕(Gx[v)Ɋւp[^
  fx:DIEFFECT;    //GtFNgSʂɂẴp[^
begin
  //̏
  RandSeed:=0;

  //^C}Zbg
  FTick:=0;
  FRestTime:=GAMETIME;

  //c@̐ݒ
  FRestHero:=NUM_RESTHERO;

  FGameState:=gsGame;

  //vCf[^̓ǂݏ|C^̃Zbg
  //IReplay:=0;

  //tH[XtB[hobNGtFNg̍쐬cΉĂȂ
  if Joy.IsFFJoyStick[2] then begin
    /////܂́A{Iȃp[^ł߂

    //X,Y֌W
    axes[0]:=DIJOFS_X;
    axes[1]:=DIJOFS_Y;

    //X=0x Y=0x
    direction[0]:=0;
    direction[1]:=0;

    with pd do begin
      dwMagnitude:=DI_FFNOMINALMAX div 2;
      lOffset:=0;
      dwPhase:=0;
      dwPeriod:=DI_SECONDS div 15;
    end;

    with ev do begin
      dwSize:=sizeof(ev);
      dwAttackLevel:=0;
      dwAttackTime:=0;
      dwFadeLevel:=0;
      dwFadeTime:=0;//DI_SECONDS;
    end;

    ZeroMemory(@fx,sizeof(fx));
    with fx do begin
      dwSize:=sizeof(fx);
      dwFlags:=DIEFF_POLAR Or DIEFF_OBJECTOFFSETS;
      dwDuration:=INFINITE;//DI_SECONDS * 2;
      dwSamplePeriod:=0;
      dwGain:=DI_FFNOMINALMAX;
      dwTriggerButton:=DIJOFS_BUTTON0 + BTN_SHOT;
      dwTriggerRepeatInterval:=0;
      cAxes:=2;
      rgdwAxes:=@axes;
      rglDirection:=@direction;
      lpEnvelope:=@ev;
      cbTypeSpecificParams:=sizeof(pd);
      lpvTypeSpecificParams:=@pd;
    end;

    if Assigned(FFx[FFX_SHOT1]) then
      FFx[FFX_SHOT1].Unload;
    if Assigned(FFx[FFX_SHOT2]) then
      FFx[FFX_SHOT2].Unload;
    if Assigned(FFx[FFX_DAMAGED]) then
      FFx[FFX_DAMAGED].Unload;

    if USE_FF then begin
      //m[}Vbg̃GtFNg
      Joy.JoySticks[2].CreateEffect(@GUID_Sine,@fx,FFx[FFX_SHOT1],Nil);

      //[K̃GtFNg
      pd.dwPeriod:=DI_SECONDS div 8;
      pd.dwMagnitude:=DI_FFNOMINALMAX;
      fx.dwTriggerButton:=DIJOFS_BUTTON0 + BTN_SHOT2;
      Joy.JoySticks[2].CreateEffect(@GUID_SawtoothUp,@fx,FFx[FFX_SHOT2],Nil);

      //@ꂽƂ̃GtFNg
      direction[0]:=9000;             //EɐU
      pd.dwPeriod:=DI_SECONDS div 3;  //ƌȊ
      fx.dwDuration:=DI_SECONDS;
      fx.dwTriggerButton:=DIEB_NOTRIGGER; //DIJOFS_BUTTON2;
      Joy.JoySticks[2].CreateEffect(@GUID_Sine,@fx,FFx[FFX_DAMAGED],Nil);
    end;

  end;


  //q[[̐
  Add(THero.Create(Self));

  //̑Rc̐
  Scheduler:=TScheduler.Create(Self);
  Scheduler.Spawn;

  //XRA\
  FScore:=0;
  Add(TScoreDisplay.Create(Self));
end;

//Q[IāA^Cgɖ߂
procedure TMoverList.GameEnd;
var
  i:Integer;
begin
  FGameState:=gsTitle;

  //MoverS
  For i:=0 to Count-1 do
    Movers[i].Die;

  //^Cgp
  TitleStart;
end;


//^Cg̕\
procedure TMoverList.TitleStart;
begin
  FGameState:=gsTitle;
  Add(TTitle.Create(Self));
end;


//ʂtbV
procedure TMoverList.Flash(col:TColor);
begin
  FFlash:=True;
  FFlashCol:=QD.TColorToPhysical(col);
end;



/////////////////////////////////////////
// TScheduler
/////////////////////////////////////////
constructor TScheduler.Create(owner:TMoverList);
begin
  inherited;

  iFate:=0;
  FAttr:=maThru;
  Fate:=TStringList.Create;
  Fate.LoadFromFile(PATH + 'position.tbl');
end;

destructor TScheduler.Destroy;
begin
   Fate.Free;

  inherited;
end;

//XPW[ɏ]āAґzu
procedure TScheduler.Spawn;
var
  n:Integer;
  g:TMover;
begin

  n:=StrToInt(Fate[iFate]); //ґԍ𓾂
  Inc(iFate);

  if iFate >= Fate.Count then
    iFate:=0;

  //ґ̐
  Case n of
    0:  g:=TZako1SineGroup.Create(FOwner);              //G1 TC
    1:  g:=TZako5Group.Create(FOwner);                  //G5 J
    2:  g:=TZako2Group.Create(FOwner);                  //G2 3A
    3:  g:=TZako3Group.Create(FOwner);                  //G3
    4:  g:=TZako1SurroundGroup.Create(FOwner);          //G荞
    5:  g:=TZako4Group.Create(FOwner);                  //a
    6:  g:=TZako1UGroup.Create(FOwner);                 //G1̋tU
    7:  g:=TZako1VGroup.Create(FOwner);                 //V̎
    8:  g:=TZako1SinAndZako2Group.Create(FOwner);       //G21
    9:  g:=TZako5StraightGroup.Create(FOwner);          //G5A꒼
    10: g:=TZako5StraightAndZako3Group.Create(FOwner);  //G5A꒼ & G3
    11: g:=TBoss1Group.Create(FOwner);                  //{X
    12: g:=TZako6Group.Create(FOwner);                  //G6(WOUO)App
    13: g:=TZako7Group.Create(FOwner);                  //G7([U)A
    14: g:=TZako8Group.Create(FOwner);                  //G8(z[~O[U)A3@
    15: g:=TBoss2Group.Create(FOwner);                  //{X2
    16: g:=TZako8SingleGroup.Create(FOwner);            //G8(P@)
    17: g:=TSilentGroup.Create(FOwner);                 //5b҂

    99: begin //Q[NA
      Fowner.Add(TGameClear.Create(FOwner));
      FOwner.FGameState:=gsGameOver;
      exit;
    end;
  end;

  g.Parent:=Self;
  FOwner.Add(g);

end;

procedure TScheduler.CatchMessage(msg:Word; Param:Pointer);
begin
  if FOwner.GameState = gsGame then
    Spawn;
end;




end.
