unit boss2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DDSD, dddd, ddddut, dddd3dut, ddid, defs, shkernel, moveUtil, enemy, flare, zangai, s_MathPack, Primitives,
  d3d,d3dtypes,d3dcaps,SE;

type

TBoss2Laser = class;

//{X
TBoss2 = class(TMover)
  private
    FState:Integer;      //
    StateChangeT:Integer; //ԑJڂN
    StateT:Integer;     //݂̏ԂɈڂĂ̎
    Pos:TVector2D;      //ʒu
    ShotCount:Integer;
    PrevShotT:DWord;
    Direction:TVector2D; //
    Step:Integer;
    Tail:Array[0..1,0..31] of TVector2D;  //̋O(0͍A1͐؂)
    Laser:TBoss2Laser;
    procedure SetState(v:Integer);
    property State:Integer read FState write setState;
  public
    Velocity:TVector2D;  //x
    constructor Create(owner:TMoverList; p:TPoint);
    procedure Move(t:Integer); override;
    procedure OnDamaged(dmg:Integer); override;
    procedure OnCrush(Target:TMover); override;
    procedure OnDie; override;
end;

//ɑ[UpAz
TBoss2Charge = class(TMover)
  private
    DotPos:TVector2D;                 //p[eBN̈ʒu
    CenterPos:TVector2D;              //z݈ʒu
    DelayT:Integer;
  public
    constructor Create(owner:TMoverList; p:TVector2D; delay:Integer);
    procedure Move(t:Integer); override;
end;

TBoss2Laser = class(TMover)
  public
    constructor Create(owner:TMoverList; p:TVector2D); //p̓[Ȕ[
    procedure Move(t:Integer); override;
    procedure OnCrush(Target:TMover); override;
    procedure OnDie; override;
end;



//c[
TDyingBoss2 = class(TTransMover)
  private
    Pos:TVector2D;        //ʒu
    Direction:TVector2D;  //
  public
    constructor Create(owner:TMoverList; p,dir:TVector2D);  //ʒuƌ
    procedure Move(t:Integer); override;
end;


TBoss2Ball = class(TMover)
  private
    Pos,Velocity:TVector2D;
    LastT:Integer;          //
  public
    constructor Create(owner:TMoverList; p0,target:TVector2D);  //ʒuƖړIn_
    procedure Move(t:Integer); override;
end;


implementation

constructor TBoss2.Create(owner:TMoverList; p:TPoint);
begin
  inherited Create(owner);


  //ϐ̏
  X:=p.X;
  Y:=P.Y;
  Pos:=Vector2D(p.X,p.Y);
  State:=0;
  Direction:=Vector2D(0,1);
  Laser:=Nil;
  Step:=0;

  //{X2ƐĂ鎞Ԃ̓JEgȂ
  FOwner.TimeStop:=True;

  //蔻̏
  HP:=3000;
  FAttr:=maEnemy;
  nTouchRect:=6;
  FTouchRect[0]:=Bounds( 22-128, 98-128, 208,101);
  FTouchRect[1]:=Bounds( 26-128,193-128,  38, 30);
  FTouchRect[2]:=Bounds(198-128,193-127,  38, 30);
  FTouchRect[3]:=Bounds(109-128,195-128,  40, 23);
  FTouchRect[4]:=Bounds( 30-128, 51-128, 199, 47);
  FTouchRect[5]:=Bounds(112-128, 13-128,  37, 35);
end;


//ԑJڂɂƂȂ
procedure TBoss2.SetState(v:Integer);
begin
  FState:=v;
  StateChangeT:=AgeT;
  StateT:=0;
end;



procedure TBoss2.Move(t:Integer);
var
  i:Integer;
  dir,right:TVector2D;

  //``̕`p
  lt,p1,p2,p3,p4,ofsX,ofsY:Tvector2D; //X^GtFNǧvZp
  tex:TDDDDTexture;
  xx:Integer;
  TLVs:Array[0..4] of D3DTLVertex;
  col:DWord;

  //lenŁAr[T[x`
  procedure DrawSabre(len:Single; ofs:TVector2D; col:DWord);
  var
    dir,right:TVector2D;  //̌vZp
    pivot:TVector2D;  //̕t
    edge:TVector2D;   //؂̍W
    mid:TVector2D;    //؂ƕt̒_(蔻蔭_)
  begin
    dir:=Direction;
    right:=Vector2D(-dir.Y,dir.X);

    //tƐ؂̈ʒuZo
    pivot:=NowAdd2D(Pos,NowAdd2D(NowScale2D(dir,128-53),NowScale2D(right,216-128)));
    edge:=NowAdd2D(pivot,NowScale2D(dir,len));

    //̃J^``
    FOwner.Rend.PushPattern2D(P_SABRE,
        NowAdd2D( NowSub2D(edge,  NowScale2D(right,14)), ofs),
        NowAdd2D( NowAdd2D(edge,  NowScale2D(right,14)), ofs),
        NowAdd2D( NowSub2D(pivot, NowScale2D(right,14)), ofs),
        NowAdd2D( NowAdd2D(pivot, NowScale2D(right,14)), ofs)
      ,
      Z_LOWER,
      bmAdd,
      col);

    //`̌vZcĝ2ӏ
    mid:=NowSub2D( NowScale2D(NowAdd2D(NowScale2D(edge,2.0),pivot),1/3) ,Pos);
    FTouchRect[6]:=Bounds(Round(mid.X)-16,Round(mid.Y)-16,32,32);
    mid:=NowSub2D( NowScale2D(NowAdd2D(NowScale2D(pivot,2.0),edge),1/3) ,Pos);
    FTouchRect[7]:=Bounds(Round(mid.X)-16,Round(mid.Y)-16,32,32);
  end;

  //K̈ʒu
  procedure InitTailPos;
  var
    i:Integer;
    dir,right:TVector2D;  //̌vZp
    pivot:TVector2D;  //̕t
    edge:TVector2D;   //؂̍W
  begin
    dir:=Direction;
    right:=Vector2D(-dir.Y,dir.X);

    //tƐ؂̈ʒuZo
    pivot:=NowAdd2D(Pos,NowAdd2D(NowScale2D(dir,128-53),NowScale2D(right,216-128)));
    edge:=NowAdd2D(pivot,NowScale2D(dir,198));

    //zɃRs[
    For i:=0 to High(Tail[0]) do begin
      Tail[0,i]:=pivot;
      Tail[1,i]:=edge;
    end;
  end;

  //K̕`
  procedure DrawTail;
  var
    i,j:Integer;
    dir,right:TVector2D;  //̌vZp
    pivot:TVector2D;  //̕t
    edge:TVector2D;   //؂̍W
  begin
    dir:=Direction;
    right:=Vector2D(-dir.Y,dir.X);

    //tƐ؂̈ʒuZo
    pivot:=NowAdd2D(Pos,NowAdd2D(NowScale2D(dir,128-53),NowScale2D(right,216-128)));
    edge:=NowAdd2D(pivot,NowScale2D(dir,198));

    //ۂ邸`
    For j:=0 to t-1 do begin
      For i:=High(Tail[0]) downto 1 do begin
        Tail[0,i]:=Tail[0,i-1];
        Tail[1,i]:=Tail[1,i-1];
      end;
    end;
    Tail[0,0]:=pivot;
    Tail[1,0]:=edge;

    //`
    For i:=0 to High(Tail[0])-1 do begin
      FOwner.Rend.Push2D(Nil, Tail[1,i],Tail[1,i+1],Tail[0,i],Tail[0,i+1],Z_ESHOT,bmAdd,NowScaleColor($FF80C0FF, 1.2 - i / High(Tail[0])));
    end;
  end;


begin
  inherited;

  Inc(StateT,t);

  Case State of

    ///////////////////////o
    0: begin
      Pos.Y:=Pos.Y + 4*t; //Ɉړ
      if Pos.Y >= 128 then begin
        State:=10;
      end;
    end;

    //////////////////////TCJ[u`Ae
    10: begin
      //6bAU160hbg
      Pos.X:=Sin(2.0 * Pi * StateT/360.0) * 160.0 + 320;

      //e(ŏ1/3b͌Ȃ)
      if CanShootConst(0,GAMELEVEL*4) And (StateT > 20) then begin
        For i:=0 to 2 do begin
          if (ShotCount And 1) = 0 then begin
            FOwner.Add(TEnemyShot1.Create(FOwner,Point(Round(Pos.X) +  67-128, Round(Pos.Y) + 217-128), NowRot2D(Vector2D(0,(4+i*2) / 2), -384*i)));
            FOwner.Add(TEnemyShot1.Create(FOwner,Point(Round(Pos.X) +  67-128, Round(Pos.Y) + 217-128), NowRot2D(Vector2D(0,(4+i*2) / 2), +256*i)));
            FOwner.Add(TEnemyShot1.Create(FOwner,Point(Round(Pos.X) + 170-128, Round(Pos.Y) + 217-128), NowRot2D(Vector2D(0,(4+i*2) / 2), -256*i)));
            FOwner.Add(TEnemyShot1.Create(FOwner,Point(Round(Pos.X) + 170-128, Round(Pos.Y) + 217-128), NowRot2D(Vector2D(0,(4+i*2) / 2), +256*i)));
          end else begin
            FOwner.Add(TEnemyShot1.Create(FOwner,Point(Round(Pos.X) +  67-128, Round(Pos.Y) + 217-128), NowRot2D(Vector2D(0,(4+i*2) / 2), -256*i)));
            FOwner.Add(TEnemyShot1.Create(FOwner,Point(Round(Pos.X) +  67-128, Round(Pos.Y) + 217-128), NowRot2D(Vector2D(0,(4+i*2) / 2), -384*i)));
            FOwner.Add(TEnemyShot1.Create(FOwner,Point(Round(Pos.X) + 170-128, Round(Pos.Y) + 217-128), NowRot2D(Vector2D(0,(4+i*2) / 2), -384*i)));
            FOwner.Add(TEnemyShot1.Create(FOwner,Point(Round(Pos.X) + 170-128, Round(Pos.Y) + 217-128), NowRot2D(Vector2D(0,(4+i*2) / 2), -384*i)));
          end;
          FOwner.Add(TEnemyShot2.Create(FOwner,Point(Round(Pos.X) +  67-128, Round(Pos.Y) + 217-128), NowRot2D(Vector2D(0,4+i*2), 0)));
          FOwner.Add(TEnemyShot2.Create(FOwner,Point(Round(Pos.X) + 170-128, Round(Pos.Y) + 217-128), NowRot2D(Vector2D(0,4+i*2), 0)));

          Inc(ShotCount);
        end;
      end;

      //ɉ鎖ւ̏u
      if (FOwner.HeroPos.Y < 100) And CanShootConst(1,4) then begin
        FOwner.Add(THomingLaser.Create(FOwner, Vector2D(Pos.X +  37-128,Pos.Y + 37-128), NowRot2D(Vector2D( 24,0),-ShotCount*256), $FFFFC080, 30));
        FOwner.Add(THomingLaser.Create(FOwner, Vector2D(Pos.X + 220-128,Pos.Y + 37-128), NowRot2D(Vector2D(-24,0),+ShotCount*256), $FFFFC080, 30));
      end;

      if StateT >= 360 then begin
        ShotCount:=0;

        Case Step And 3 of
          0:State:=20;  //ːiz[~OC
          1:State:=40;  //
          2:State:=50;  //̏z[~OC
          3:State:=30;   //9;   //`[WɑC
        end;
        Inc(Step);
      end;
    end;


    /////////////////////ːiz[~OC
    //˂ޑÕvv
    20: begin
      Pos:=Vector2D(320 + Random * 6.0 - 3.0, 128 + Random * 6.0 - 3.0);

      if StateT > 30 then begin
        Pos:=Vector2D(320,128);
        State:=21;
        Velocity:=Vector2D(0,0);
      end;
    end;
    //˂
    21: begin
      Velocity.Y:=Velocity.Y + 0.5;
      if Velocity.Y > 12 then
        Velocity.Y:=12;
      Pos.Y:=Pos.Y + Velocity.Y * t;

      if Pos.Y > 512 then begin
        Pos.Y:=512;
        State:=22;
      end;
    end;
    //vv
    22: begin
      Pos:=Vector2D(320 + Random * 30.0 / (StateT+1) - 3.0, 512 + Random * 30.0 / (StateT+1) -3.0);

      if StateT > 30 then begin
        Pos:=Vector2D(320,512);
        ShotCount:=0;
        State:=23;
      end;
    end;
    //Ƀz[~OC
    23: begin
      if CanShootConst(0,8) then begin
        FOwner.Add(THomingLaser.Create(FOwner, Vector2D(Pos.X +  37-128,Pos.Y + 37-128), NowRot2D(Vector2D( 24,0),-ShotCount*256), $FFFFC080, 30));
        FOwner.Add(THomingLaser.Create(FOwner, Vector2D(Pos.X + 220-128,Pos.Y + 37-128), NowRot2D(Vector2D(-24,0),+ShotCount*256), $FFFFC080, 30));
        Inc(ShotCount);
      end;
      if ShotCount >= GAMELEVEL * 8 + 4 then
        State:=24;
    end;
    //]
    24: begin
      Direction:=NowRot2D(Vector2D(0,1),StateT * (4096 div 60) * t);
      if StateT > 2048 div 60 then begin
        State:=25;
        Direction:=Vector2D(0,-1);
        Velocity:=Vector2D(0,0);
      end;
    end;
    //オĂ
    25: begin
      Velocity.Y:=Velocity.Y - 0.5;
      if Velocity.Y < -12 then
        Velocity.Y:=-12;
      Pos.Y:=Pos.Y + Velocity.Y*t;

      if Pos.Y < 128 then begin
        Pos.Y:=128;
        State:=26;
      end;
    end;
    //]
    26: begin
      Direction:=NowRot2D(Vector2D(0,-1),StateT * (4096 div 60) * t);
      if StateT > 2048 div 60 then begin
        State:=10;
        Direction:=Vector2D(0,1);
      end;
    end;


    //////////////////////////////ɑ[U
    //`[W
    30: begin
      if StateT < 120 then
        FOwner.Add(TBoss2Charge.Create(FOwner,Vector2D(X,Y+200-128), Random(3)));
      if StateT > 180 then
        State:=31;
    end;
    //ɑ[U
    31: begin
      Laser:=TBoss2Laser.Create(Fowner,Vector2D(X,Y+195-128) );
      FOwner.Add(Laser);
      State:=32;
    end;
    //҂
    32: begin
      if StateT > 240 then begin
        Laser.Die;
        Laser:=Nil;
        State:=10;
      end;
    end;



    //////////////////////////////
    //E]
    40: begin
      Direction:=NowRot2D(Vector2D(0,1),4096 div 5 div 30 * StateT);
      if StateT > 30 then begin
        Direction:=NowRot2D(Vector2D(0,1),4096 div 5);
        State:=41;
      end;
    end;
    // T[xo
    41: begin
      NTouchRect:=8;  //蔻𑝂₷
      DrawSabre(StateT*19,Vector2D(0,0),$FFFFFFFF);
      if StateT > 10 then
        State:=42;
    end;
    // T[x炷
    42: begin
      DrawSabre(198,Vector2D(0,0),$FFFFFFFF);
      DrawSabre(198,Vector2D(MvRandom(4),MvRandom(4)),$FF404040);
      DrawSabre(198,Vector2D(MvRandom(4),MvRandom(4)),$FF404040);
      if StateT > 20 then begin
        //K̈ʒuvZ
        InitTailPos;
        State:=43;
      end;
    end;
    //P
    43: begin
      Pos:=MvInterPolate(
        [
          Vector2D(320,128),
          Vector2D(128,480),
          Vector2D(320,700),
          Vector2D(512,480),
          Vector2D(320,128)
        ],StateT,90);

      DrawSabre(198,Vector2D(0,0),$FFFFFFFF);
      DrawTail;
      Direction:=NowRot2D(Vector2D(0,1),4096 div 5 - 4096 div 45 * StateT);

      if StateT > 90 then
        State:=44;
    end;
    //c܂܂ŁA҂
    44: begin
      Pos:=Vector2D(320 + Random * 30.0 / (StateT+1) - 3.0, 128 + Random * 30.0 / (StateT+1) -3.0);
      DrawSabre(198,Vector2D(0,0),$FFFFFFFF);
      DrawTail;
      if StateT > High(Tail[0]) + 10 then
        State:=45;
    end;
    //T[x߂
    45: begin
      NTouchRect:=6;  //蔻萔߂
      DrawSabre((10 - StateT)*19,Vector2D(0,0),$FFFFFFFF);
      if StateT > 10 then
        State:=46;
    end;
    //]
    46: begin
      Direction:=NowRot2D(Vector2D(0,1),4096 div 5 div 30 * (30-StateT));
      if StateT > 30 then begin
        Direction:=Vector2D(0,1);
        State:=10;
      end;
    end;


    //////////////////////////////̏z[~OC
    //̏z[~OC
    50:begin
      if CanShootConst(0,8) then begin
        FOwner.Add(THomingLaser.Create(FOwner, Vector2D(Pos.X +  37-128,Pos.Y + 37-128), NowRot2D(Vector2D( 24,0),-ShotCount*256), $FFFFC080, 30));
        FOwner.Add(THomingLaser.Create(FOwner, Vector2D(Pos.X + 220-128,Pos.Y + 37-128), NowRot2D(Vector2D(-24,0),+ShotCount*256), $FFFFC080, 30));
        Inc(ShotCount);
      end;
      if ShotCount >= GAMELEVEL * 4 + 4 then
        State:=10;
    end;
  end;

  X:=Round(Pos.X);
  Y:=Round(Pos.Y);

  //`
  dir:=NowScale2D(Direction,128);
  right:=Vector2D(-dir.Y,dir.X);


  //Cȏ
  FOwner.Rend.PushPattern2D(
    P_BOSS2,
      NowAdd2D(NowSub2D(Pos,right),dir),
      NowAdd2D(NowAdd2D(Pos,right),dir),
      NowSub2D(NowSub2D(Pos,right),dir),
      NowSub2D(NowAdd2D(Pos,right),dir)
    ,
    Z_NORMAL,bmDecal,$FFFFFFFF);

  //ɂ̏ꍇAI[o[bvămCY̍ڂ{XG`
  if (HP < 500) And (Random < 0.125) then begin
    lt:=NowAdd2D(NowSub2D(Pos,right),dir);  //]̍
    ofsX:=NowChangeLength2D(right,4); //PXꍇX̕ω
    ofsY:=NowNormalize2D(dir);        // 1.0YꍇY̕ω
    ofsY:=Vector2D(-ofsY.X,-ofsY.Y);

    tex:=FOwner.Textures['boss2.bmp'];

    //4hbgŃX^GtFNg܂
    For xx:=0 to 63 do begin

      p1:=NowAdd2D(lt, NowAdd2D( NowScale2D(ofsX,xx), NowScale2D(ofsY,(Random-0.5)*50)));
      p2:=NowAdd2D(p1, ofsX);
      p3:=NowAdd2D(p1, NowScale2D(ofsY,256));
      p4:=NowAdd2D(p3, ofsX);

      col:=$FFFF0000;
      TLVs[0]:=makeTLV(p1.X,p1.Y, 0.5,0.5, col,0,     xx/64,0);
      TLVs[1]:=makeTLV(p2.X,p2.Y, 0.5,0.5, col,0, (xx+1)/64,0);
      TLVs[2]:=makeTLV(p3.X,p3.Y, 0.5,0.5, col,0,     xx/64,1.0);
      TLVs[3]:=makeTLV(p4.X,p4.Y, 0.5,0.5, col,0, (xx+1)/64,1.0);

      FOwner.Rend.Push(tex,TLVs[0],TLVs[1],TLVs[2],TLVs[3],Z_HIGH,bmAdd);
    end;
  end;

end;




procedure TBoss2.OnDamaged(dmg:Integer);
var
  info:TDestroyInfo;
begin
  inherited;

  //HP炷
  Dec(HP,dmg);

  //HP0ȉɂȂA
  if HP <= 0 then begin
    FOwner.Score:=FOwner.Score + SC_BOSS2;
    //FOwner.Add(TDyingBoss1.Create(FOwner,X,Y));
    info.x:=x;
    info.y:=y;
    info.point:=SC_BOSS2;
    SendMessage(Parent,MSG_DESTROYED,@info);

    //r[u
    FOwner.Add(TDyingBoss2.Create(FOwner,Pos,Direction));

    Die;
  end;
end;




procedure TBoss2.OnCrush(Target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(10);
end;


procedure TBoss2.OnDie;
begin
  inherited;

  if Laser <> Nil then
    Laser.Die;

  //Ԃ̗߂
  FOwner.TimeStop:=False;

end;








/////////////////////////////
// ɑ[UpAz
/////////////////////////////

constructor TBoss2Charge.Create(owner:TMoverList; p:TVector2D; delay:Integer);
begin
  inherited Create(owner);

  CenterPos:=p;
  DotPos:=Vector2D(p.X + Random * 128 - 64,  p.Y + Random * 64.0 + 32.0);
  DelayT:=delay;

  FAttr:=maThru;
end;

procedure TBoss2Charge.Move(t:Integer);
var
  dir,right:TVector2D;
  dist:Single;
begin
  inherited;

  if AgeT > DelayT then begin
    NowDistance2D(dist,DotPos,CenterPos);

    dir:=NowChangeLength2D(NowSub2D(CenterPos,DotPos), (AgeT-DelayT)/60.0 * dist + 32.0);
    right:=NowChangeLength2D(Vector2D(-dir.Y,dir.X), 128.0 / ((AgeT-DelayT)/60.0 * dist + 32.0));

    FOwner.Rend.PushPattern2D(P_BALL,
        NowSub2D(NowAdd2D(DotPos,dir),right),
        NowAdd2D(NowAdd2D(DotPos,dir),right),
        NowSub2D(DotPos,right),
        NowAdd2D(DotPos,right)
      ,
      Z_FLARE,bmAdd,NowScaleColor($FF80C0FF,1.0 - (AgeT-DelayT) / 60.0));
  end;

  if AgeT-DelayT > 60 then
    Die;
end;



////////////////////////////
// {X2̃[U
////////////////////////////
constructor TBoss2Laser.Create(owner:TMoverList; p:TVector2D); //p̓[Ȕ[
begin
  Inherited Create(Owner);

  //蔻̏
  FAttr:=maEB;
  FSubAttr:=[moEnemyLaser];
  nTouchRect:=1;
  FTouchRect[0]:=Rect(-32,0,+32,480); //ʉ܂

  //ˉ
  SG.LoopPlay(CH_ENEMY3,PR_TOP,SE_GOKUBUTO1);

  X:=Round(p.X);
  Y:=Round(p.Y);
end;

procedure TBoss2Laser.Move(t:Integer);
  //awidth, Fcol̃[U`
  procedure DrawLay(width:Integer; col:DWord);
  begin
    FOwner.Rend.PushPattern2D(P_RIBBON,
      Vector2D(X-width,Y),Vector2D(X+width,Y),Vector2D(X-width,480),Vector2D(X+width,480),
      Z_ESHOT,
      bmAdd,
      col);
  end;

  //Zp`B͍΂ߏ45x瓖ĂƂ
  procedure DrawHexPost(radius:Single; col:DWord; angle:Integer; mode:TBlendMode);  //Oډ~̔aAFApx
  var
    lv:TVector2D; //xNg
    fv:TVector2D; //ʂ̖@xNg
    l,r:Single;   //ƉE̍W
    prod:Single;  //xNgƖʂ̖@xNg̓
    i:Integer;
  begin
    lv:=Vector2D(0,1);

    for i:=0 to 5 do begin
      //ʂ̖@Ƃ̓ς߂
      fv:=NowRot2D(Vector2D(0,-1),angle + i*4096 div 6);
      NowDotProduct2D(prod, lv,fv);

      if prod < 0 then begin
        //ʂ̉ʏł̍ƉE̍W߂
        fv:=NowScale2D(fv,radius);
        r:=NowRot2D(fv,4096 div 12).X + X;
        l:=NowRot2D(fv,- (4096 div 12)).X + X;

        FOwner.Rend.PushPattern2D(P_RIBBON,
          Vector2D(l,Y),Vector2D(r,Y),Vector2D(l,480),Vector2D(r,480),
          Z_ESHOT,
          mode,
          NowScaleColor(col, -prod));

      end;

    end;
  end;
begin
  inherited;

  //̃Of
  {
  DrawLay(6, $FFC0C0C0);
  DrawLay(7, $FF808080);
  DrawLay(8, $FF404040);

  //
  DrawLay((AgeT And 7) + 7, $FF2020C0);
  }

  //DrawHexPost(8,$FF808080, AgeT*64, bmDecal);
  //DrawHexPost(8,$80FF4040,-AgeT*57, bmAlpha);
  DrawHexPost(16 + Random(24),$FF000000 + Random($1000000),0, bmAdd);
  DrawHexPost(16 + Random(32),$FF4080FF,0, bmAdd);
  DrawHexPost(24 + Random(32),$FF4080FF,0, bmAdd);

end;


procedure TBoss2Laser.OnCrush(Target:TMover);
begin
  inherited;

  if target.Attr = maHero then
    target.OnDamaged(1);
end;


procedure TBoss2Laser.OnDie;
begin
  inherited;
  SG.Stop(CH_ENEMY3);
end;










////////////////////////////////
// {X2̎c[
////////////////////////////////

constructor TDyingBoss2.Create(owner:TMoverList; p,dir:TVector2D);
begin
  inherited Create(owner);

  FAttr:=maThru;

  Pos:=p;
  Direction:=dir;
  State:=0;
end;

procedure TDyingBoss2.Move(t:Integer);
var
  dir,right:TVector2D;
  lt,p1,p2,p3,p4,ofsX,ofsY:Tvector2D; //X^GtFNǧvZp
  tex:TDDDDTexture;
  x:Integer;
  TLVs:Array[0..4] of D3DTLVertex;
  col:DWord;
begin
  inherited;

  dir:=NowScale2D(Direction,128);
  right:=Vector2D(-dir.Y,dir.X);

  Case State of

    //eIۂ΂̋ʂ & _ŃtbVC
    0: begin
      if CanShootConst(0,30) then begin
        SG.Play(CH_ENEMY1,PR_NORMAL,SE_ShootDown1);
        FOwner.Add(TBoss2Ball.Create(FOwner, NowAdd2D(Pos,NowRandom2D(320.0)), Pos));
      end;

      if CanShootRandom(3) then begin
        SG.Play(CH_ENEMY2,PR_HIGH,SE_ShootDown2);
        FOwner.Add(TFlare2.Create(FOwner,Round(Pos.X + MvRandom(64)),Round(Pos.Y+MvRandom(64)),Random(12)));
        FOwner.Add(TFlare2.Create(FOwner,Round(Pos.X + MvRandom(64)),Round(Pos.Y+MvRandom(64)),Random(12)));
        FOwner.Add(TFlare2.Create(FOwner,Round(Pos.X + MvRandom(64)),Round(Pos.Y+MvRandom(64)),Random(12)));
        FOwner.Add(TFlare2.Create(FOwner,Round(Pos.X + MvRandom(64)),Round(Pos.Y+MvRandom(64)),Random(12)));
        FOwner.Add(TSpark2.Create(FOwner,16,0,512,Round(Pos.X),Round(Pos.Y)));
        FOwner.Flash(clWhite);
      end;

      //{X`
      FOwner.Rend.PushPattern2D(
        P_BOSS2,
          NowAdd2D(NowSub2D(Pos,right),dir),
          NowAdd2D(NowAdd2D(Pos,right),dir),
          NowSub2D(NowSub2D(Pos,right),dir),
          NowSub2D(NowAdd2D(Pos,right),dir)
        ,
        Z_NORMAL,bmAdd,NowScaleColor($FFFFFFFF,1.0-AgeT/240));
      //{X̎p`(ԂŉF)
      FOwner.Rend.PushPattern2D(
        P_BOSS2,
          NowAdd2D(NowSub2D(Pos,right),dir),
          NowAdd2D(NowAdd2D(Pos,right),dir),
          NowSub2D(NowSub2D(Pos,right),dir),
          NowSub2D(NowAdd2D(Pos,right),dir)
        ,
        Z_NORMAL,bmAdd,NowScaleColor($FFFF0000,AgeT/240));


      if AgeT > 240 then begin
        //j
        SG.Play(CH_ENEMY2,PR_HIGH,SE_ShootDown2);
        State := 10;
      end;
    end;

    //X^GtFNgH
    10: begin
      lt:=NowAdd2D(NowSub2D(Pos,right),dir);  //]̍
      ofsX:=NowChangeLength2D(right,4); //PXꍇX̕ω
      ofsY:=NowNormalize2D(dir);        // 1.0YꍇY̕ω
      ofsY:=Vector2D(-ofsY.X,-ofsY.Y);

      tex:=FOwner.Textures['boss2.bmp'];

      //4hbgŃX^GtFNg܂
      For x:=0 to 63 do begin

        p1:=NowAdd2D(lt, NowAdd2D( NowScale2D(ofsX,x), NowScale2D(ofsY,(Random-0.5)*StateT*StateT/20.0) ));
        p2:=NowAdd2D(p1, ofsX);
        p3:=NowAdd2D(p1, NowScale2D(ofsY,256));
        p4:=NowAdd2D(p3, ofsX);

        col:=NowScaleColor($FFFF0000,1.5-StateT/64.0);
        TLVs[0]:=makeTLV(p1.X,p1.Y, 0.5,0.5, col,0,     x/64,0);
        TLVs[1]:=makeTLV(p2.X,p2.Y, 0.5,0.5, col,0, (x+1)/64,0);
        TLVs[2]:=makeTLV(p3.X,p3.Y, 0.5,0.5, col,0,     x/64,1.0);
        TLVs[3]:=makeTLV(p4.X,p4.Y, 0.5,0.5, col,0, (x+1)/64,1.0);

        FOwner.Rend.Push(tex,TLVs[0],TLVs[1],TLVs[2],TLVs[3],Z_NORMAL,bmAdd);
      end;

      //EF[u
      if CanShootRandom(8) then
        FOwner.Add(TShockWave2.Create(FOwner,Round(Pos.X),Round(Pos.Y),0,NowScaleColor($FF000000+Random($01000000),0.50)));

      if StateT > 64 then
        Die;  //I
    end;

  end;
end;




////////////////////////////////
// {X2̉΂̋
////////////////////////////////

constructor TBoss2Ball.Create(owner:TMoverList; p0,target:TVector2D);  //ʒuƖړIn_
var
  d:Single;
begin
  inherited Create(owner);

  FAttr:=maThru;

  //ݒnƖړInAxxNgƁAB\莞vZ
  pos:=p0;
  Velocity:=NowChangeLength2D(NowSub2D(target,pos),30);

  NowDistance2D(d,target,pos);
  LastT:=Round(d / 30.0);
end;

procedure TBoss2Ball.Move(t:Integer);
var
  r:Single; //~̔a
begin
  inherited;

  Pos:=NowAdd2D(Pos,NowScale2D(Velocity,t));
  r:=96.0 * (LastT-AgeT) / LastT;

  if AgeT > LastT then
    Die
  else
    FOwner.Rend.PushPatternRect(P_FLARE2,SingleRect(Pos.X-r,Pos.Y-r,Pos.X+r,Pos.Y+r),Z_FLARE,bmAdd,$FFF0F0C0);


end;


end.
