//p^[
unit zangai;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DDSD, dddd, ddddut, ddidex, defs, shkernel, moveUtil, flare, SE;


//_ł镨
type TBlinker = class(TMover)
  private
    mySpr:Integer;    //\XvCgԍ
    v0:TPoint;        //x
    LifeT:Integer;    //(^^;)
  public
    constructor Create(owner:TMoverList; shape, gx,gy, vx,vy, lt:Integer); //VFCvԍEʒuExE
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
end;


//Zako3̂p^[
type TDyingZako3 = class(TMover)
  private
    Z3:TBlinker;      //Zako3̎p
    p0:TPoint;        //ʒu
  public
    constructor Create(owner:TMoverList; gx,gy:Integer);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
end;

//Zako2̂p^[
type TDyingZako2 = class(TMover)
  private
    Z2:TBlinker;      //Zako2̎p
    p0:TPoint;        //ʒu
  public
    constructor Create(owner:TMoverList; gx,gy:Integer);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
end;

//Zako8̂p^[
type TDyingZako8 = class(TMover)
  private
    Z8:TBlinker;      //Zako2̎p
    p0:TPoint;        //ʒu
  public
    constructor Create(owner:TMoverList; gx,gy:Integer);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
end;



//{X̃Jo[̂p^[
type TDyingBoss1Cover = class(TMover)
  private
    Cover:TBlinker;   //Jo[̎p
    p0:TPoint;        //ʒu
  public
    constructor Create(owner:TMoverList; gx,gy:Integer);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
end;


//{X̖Ĉp^[
type TDyingBoss1Weapon = class(TMover)
  private
    Weapon:TBlinker;   //̎p
    p0:TPoint;        //ʒu
    IamL:Boolean;      //l͍H
  public
    constructor Create(owner:TMoverList; gx,gy:Integer; L:Boolean);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
end;


//{X̂p^[
type TDyingBoss1 = class(TMover)
  private
    Boss1:TBlinker;   //{X̎p
    p0:TPoint;        //ʒu
  public
    constructor Create(owner:TMoverList; gx,gy:Integer);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
end;


//q[[̂p^[
type TDyingHero = class(TMover)
  private
    Hero:TBlinker;    //q[[̎p
    p0:TPoint;        //ʒu
  public
    constructor Create(owner:TMoverList; gx,gy:Integer);
    destructor Destroy; override;
    procedure Move(t:Integer); override;
    procedure MoveTo(xx,yy:Integer);
    procedure OnDie; override;
end;



implementation

////////////////////////////
// 镨
////////////////////////////

constructor TBlinker.Create(owner:TMoverList; shape, gx,gy, vx,vy, lt:Integer); //VFCvԍEʒuExE
begin
  inherited Create(owner);

  //蔻̏
  FAttr:=maThru;
  nTouchRect:=0;

  v0.x:=vx;
  v0.y:=vy;
  LifeT:=lt;

  mySpr:=FOwner.NewSprite();

  with FOwner.Spr[mySpr] do begin
    iShape:=shape;
    MinAnim:=0;
    MaxAnim:=0;
    iAnim:=0;
    Visible:=True;
    Z:=Z_NORMAL;
    AddMode:=False;
  end;

  MoveTo(gx,gy);
end;

destructor TBlinker.Destroy;
begin
  FOwner.FreeSprite(mySpr);
  inherited;
end;

procedure TBlinker.Move(t:Integer);
begin
  inherited;

  MoveTo(X+v0.x * t, Y+v0.y*t);

  with FOwner.Spr[mySpr] do begin
    Visible:=not Visible;
  end;

  if AgeT > LifeT then
    Die;

end;

procedure TBlinker.MoveTo(xx,yy:Integer);
begin
  with FOwner.Spr[mySpr] do begin
    X:=xx - Width Shr 1;
    Y:=yy - Height Shr 1;
  end;
  X:=xx;
  Y:=yy;
end;

procedure TBlinker.OnDie;
begin
  inherited;
  FOwner.Spr[mySpr].Hide;
end;





////////////////////////////
// Ȃ񂩎アZako2̂p^[
////////////////////////////

constructor TDyingZako2.Create(owner:TMoverList; gx,gy:Integer);
begin
  inherited Create(owner);

  //蔻̏
  FAttr:=maThru;
  nTouchRect:=0;

  Z2:=TBlinker.Create(FOwner, S_Zako2, gx,gy, 0,2, 46);
  FOwner.Add(z2);
  MoveTo(gx,gy);

  //ʉ炷
  SG.Play(CH_ENEMY1,PR_HIGH,SE_SHOOTDOWN2);
end;

destructor TDyingZako2.Destroy;
begin
  inherited;
end;

procedure TDyingZako2.Move(t:Integer);
var
  anim:Integer; //ւ̃Ajp^[
  f2:TFlare2;
begin
  inherited;

  //ΉԂU炵A
  if AgeT < 45 then begin
    if CanShootConst(0, 8) then begin
      //OGtFNg
      FOwner.Add(TSpark3.Create(FOwner,Z2.X-16,Z2.Y));//,16, Z2.X-16,Z2.Y));
    end;
    //GtFNg
    with FOwner.Spr[Z2.mySpr] do begin
      Width:=Width - t;
      Height:=Height - t;
    end;
  end;

  //Ɣ
  if (AgeT > 15) And (AgeT < 45) then begin
    if CanShootConst(1,8) then begin
      f2:=TFlare2.Create(FOwner, Z2.X+Random(96)-48, Z2.Y+Random(96)-48, 0);
      f2.Scale(96-AgeT,96);
      FOwner.Add(f2);
      //FOwner.Add(TFlare2.Create(FOwner, Fowner.Tick,Z2.X+Random(96)-48,Z2.Y+Random(96)-48));
    end;
  end;

  //3/4bŔ
  if AgeT > 45 then begin
    //FOwner.Add(TFlare1.Create(FOwner, Z2.X,Z2.Y, 0));
    FOwner.Add(TSpark2.Create(FOwner, 16, 0,512, Z2.X,Z2.Y));
    FOwner.Add(TSpark2.Create(FOwner, 16, 0,512, Z2.X,Z2.Y));
    {
    anim:=Random(3);
    if anim = 2 then
      FOwner.Add(TFlare3.Create(FOwner, Z2.X,Z2.Y, anim,0))
    else
      FOwner.Add(TFlare3.Create(FOwner, Z2.X,Z2.Y-16, anim,0));
    }
    FOwner.Add(TShockWave2.Create(FOwner, Z2.X,Z2.Y,0, $FFFFFFFF));
    FOwner.Add(TLensFlare2.Create(FOwner, Z2.X + MvRandom(16),Z2.Y + MvRandom(16),8,  $FFE08080));
    FOwner.Add(TLensFlare2.Create(FOwner, Z2.X + MvRandom(16),Z2.Y + MvRandom(16),16, $FFC0E080));
    FOwner.Add(TLensFlare2.Create(FOwner, Z2.X + MvRandom(16),Z2.Y + MvRandom(16),24, $FF80C0E0));

    FOWner.Flash(clWhite);

    //ʉ
    SG.Play(CH_ENEMY1,PR_HIGH,SE_SHOOTDOWN2);

    Die;
  end;

end;

procedure TDyingZako2.MoveTo(xx,yy:Integer);
begin
  X:=xx;
  Y:=yy;
end;

procedure TDyingZako2.OnDie;
begin
  inherited;
end;





////////////////////////////
// ~TC܂Zako3̂p^[
////////////////////////////

constructor TDyingZako3.Create(owner:TMoverList; gx,gy:Integer);
begin
  inherited Create(owner);

  //蔻̏
  FAttr:=maThru;
  nTouchRect:=0;

  Z3:=TBlinker.Create(FOwner, S_ZAKO3, gx,gy, 0,2, 46);
  FOwner.Add(z3);
  MoveTo(gx,gy);

  //ʉ
  SG.Play(CH_ENEMY1,PR_HIGH,SE_SHOOTDOWN2);
end;

destructor TDyingZako3.Destroy;
begin
  inherited;
end;

procedure TDyingZako3.Move(t:Integer);
begin
  inherited;

  //ΒA(?)
  if AgeT < 45 then begin
    if CanShootConst(0, 15) then begin
      //Β
      FOwner.Add(TSpark1.Create(FOwner, Z3.X-16,Z3.Y, 0,-6));
      FOwner.Add(TSpark1.Create(FOwner, Z3.X+16,Z3.Y, 0,-6));
      //GtFNg
      {
      with FOwner.Spr[Z3.mySpr] do begin
        Width:=Width-1;
        Height:=Height-1;
      end;
      }
    end;
  end;

  //Ɣ
  if (AgeT > 15) And (AgeT < 45) then begin
    if CanShootConst(1,8) then
      FOwner.Add(TFlare2.Create(FOwner, Z3.X+Random(96)-48,Z3.Y+Random(96)-48,0));
  end;

  //1/2bŔ
  if AgeT > 45 then begin
    FOwner.Add(TShockWave1.Create(FOwner, Z3.X,Z3.Y,0));
    FOwner.Add(TLensFlare1.Create(FOwner, Z3.X,Z3.Y,8));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Z3.X,Z3.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Z3.X,Z3.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Z3.X,Z3.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Z3.X,Z3.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Z3.X,Z3.Y));
    FOWner.Flash(clWhite);

    //ʉ
    SG.Play(CH_ENEMY1,PR_HIGH,SE_SHOOTDOWN2);

    Die;
  end;
end;

procedure TDyingZako3.MoveTo(xx,yy:Integer);
begin
  X:=xx;
  Y:=yy;
end;

procedure TDyingZako3.OnDie;
begin
  inherited;
end;




////////////////////////////
// ƋZako8̂p^[
////////////////////////////

constructor TDyingZako8.Create(owner:TMoverList; gx,gy:Integer);
begin
  inherited Create(owner);

  //蔻̏
  FAttr:=maThru;
  nTouchRect:=0;

  Z8:=TBlinker.Create(FOwner, S_Zako8, gx,gy, 0,2, 46);
  FOwner.Add(z8);
  MoveTo(gx,gy);

  //ʉ炷
  SG.Play(CH_ENEMY1,PR_HIGH,SE_SHOOTDOWN2);
end;

destructor TDyingZako8.Destroy;
begin
  inherited;
end;

procedure TDyingZako8.Move(t:Integer);
var
  anim:Integer; //ւ̃Ajp^[
  f2:TFlare2;
begin
  inherited;

  //ΉԂU炵A
  if AgeT < 45 then begin
    if CanShootConst(0, 8) then begin
      //OGtFNg
      FOwner.Add(TSpark3.Create(FOwner, Z8.X-16,Z8.Y));
    end;
    //GtFNg
    with FOwner.Spr[Z8.mySpr] do begin
      Width:=Width - t;
      Height:=Height - t;
    end;
  end;

  //Ɣ
  if (AgeT > 15) And (AgeT < 45) then begin
    if CanShootConst(1,8) then begin
      f2:=TFlare2.Create(FOwner, Z8.X+Random(96)-48, Z8.Y+Random(96)-48, 0);
      f2.Scale(96-AgeT,96);
      FOwner.Add(f2);
      //FOwner.Add(TFlare2.Create(FOwner, Fowner.Tick,Z2.X+Random(96)-48,Z2.Y+Random(96)-48));
    end;
  end;

  //3/4bŔ
  if AgeT > 45 then begin
    //FOwner.Add(TFlare1.Create(FOwner, Z2.X,Z2.Y, 0));
    FOwner.Add(TSpark2.Create(FOwner, 16, 0,512, Z8.X,Z8.Y));
    FOwner.Add(TSpark2.Create(FOwner, 16, 0,512, Z8.X,Z8.Y));

    //Ռg
    FOwner.Add(TShockWave3.Create(FOwner,Z8.X,Z8.Y,0,$FFFF8080));

    FOWner.Flash(clWhite);

    //ʉ
    SG.Play(CH_ENEMY1,PR_HIGH,SE_SHOOTDOWN2);

    Die;
  end;

end;

procedure TDyingZako8.MoveTo(xx,yy:Integer);
begin
  X:=xx;
  Y:=yy;
end;

procedure TDyingZako8.OnDie;
begin
  inherited;
end;





////////////////////////////
// {X̃Jo[̂p^[
////////////////////////////

constructor TDyingBoss1Cover.Create(owner:TMoverList; gx,gy:Integer);
begin
  inherited Create(owner);

  //蔻̏
  FAttr:=maThru;
  nTouchRect:=0;

  //_łJo[
  Cover:=TBlinker.Create(FOwner, S_Boss1C, gx,gy, 0,-2, 46);
  FOwner.Spr[Cover.mySpr].Z:=Z_HIGH;
  FOwner.Add(Cover);

  //
  FOwner.Add(TFlare1.Create(FOwner, Cover.X,Cover.Y,0));

  //ʉ
  SG.Play(CH_ENEMY1,PR_NORMAL,SE_SHOOTDOWN2);

  MoveTo(gx,gy);
end;

destructor TDyingBoss1Cover.Destroy;
begin
  inherited;
end;

procedure TDyingBoss1Cover.Move(t:Integer);
begin
  inherited;

  //CRtH
  if AgeT < 45 then begin
    if CanShootConst(0,3) then begin
      Inc(Cover.v0.Y);
    end;
  end;

  //3/4bŔ
  if AgeT > 45 then begin
    FOwner.Add(TFlare1.Create(FOwner, Cover.X,Cover.Y,0));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Cover.X,Cover.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Cover.X,Cover.Y));

    //ʉ
    SG.Play(CH_ENEMY1,PR_HIGH,SE_SHOOTDOWN2);

    Die;
  end;
end;

procedure TDyingBoss1Cover.MoveTo(xx,yy:Integer);
begin
  X:=xx;
  Y:=yy;
end;

procedure TDyingBoss1Cover.OnDie;
begin
  inherited;
end;





////////////////////////////
// {X̂̕p^[
////////////////////////////

constructor TDyingBoss1Weapon.Create(owner:TMoverList; gx,gy:Integer; L:Boolean);
begin
  inherited Create(owner);

  //蔻̏
  FAttr:=maThru;
  nTouchRect:=0;

  IamL:=L;

  //_ł镐
  if L then
    Weapon:=TBlinker.Create(FOwner, S_Boss1L, gx,gy, -3,-1, 46)
  else
    Weapon:=TBlinker.Create(FOwner, S_Boss1R, gx,gy, 3,-1, 46);

  FOwner.Spr[Weapon.mySpr].Z:=Z_LOWER;
  FOwner.Add(Weapon);

  //O
  FOwner.Add(TFlare2.Create(FOwner, Weapon.X+Random(64)-32, Weapon.Y-100+Random(64)-32,0));
  FOwner.Add(TFlare2.Create(FOwner, Weapon.X+Random(64)-32, Weapon.Y+Random(64)-32,0));
  FOwner.Add(TFlare2.Create(FOwner, Weapon.X+Random(64)-32, Weapon.Y+100+Random(64)-32,0));

  //ʉ
  SG.Play(CH_ENEMY1,PR_HIGH,SE_SHOOTDOWN2);

  MoveTo(gx,gy);
end;

destructor TDyingBoss1Weapon.Destroy;
begin
  inherited;
end;

procedure TDyingBoss1Weapon.Move(t:Integer);
begin
  inherited;

  //CRtH
  if AgeT < 45 then begin
    if CanShootConst(0,4) then begin
      Weapon.v0.Y:=MvBreaking(Weapon.v0.Y,1);
      Weapon.v0.X:=MvBreaking(Weapon.v0.X,1);
    end;
  end;

  //ʊԍۂɔ
  if AgeT > 40 then begin
    FOwner.Add(TFlare2.Create(FOwner, Weapon.X+Random(64)-32, Weapon.Y+Random(264)-132,0));
  end;

  //3/4bŔ
  if AgeT > 45 then begin
    FOwner.Add(TFlare1.Create(FOwner, Weapon.X,Weapon.Y,0));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Weapon.X,Weapon.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Weapon.X,Weapon.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Weapon.X,Weapon.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Weapon.X,Weapon.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Weapon.X,Weapon.Y));
    FOWner.Flash(clGreen);

    //ʉ
    SG.Play(CH_ENEMY1,PR_HIGH,SE_SHOOTDOWN2);

    Die;
  end;
end;

procedure TDyingBoss1Weapon.MoveTo(xx,yy:Integer);
begin
  X:=xx;
  Y:=yy;
end;

procedure TDyingBoss1Weapon.OnDie;
begin
  inherited;
end;







////////////////////////////
// {X̂p^[
////////////////////////////

constructor TDyingBoss1.Create(owner:TMoverList; gx,gy:Integer);
begin
  inherited Create(owner);

  //蔻̏
  FAttr:=maThru;
  nTouchRect:=0;


  //_ł{X
  Boss1:=TBlinker.Create(FOwner, S_Boss1, gx,gy, 0,1, 91);
  FOwner.Add(Boss1);
  FOwner.Spr[Boss1.mySpr].Z:=Z_LOWER;


  //O
  FOwner.Add(TFlare2.Create(FOwner, Boss1.X+Random(220)-110, Boss1.Y+Random(220)-110,0));
  FOwner.Add(TFlare2.Create(FOwner, Boss1.X+Random(220)-110, Boss1.Y+Random(220)-110,2));
  FOwner.Add(TFlare2.Create(FOwner, Boss1.X+Random(220)-110, Boss1.Y+Random(220)-110,4));

  //΂̕
  FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Boss1.X,Boss1.Y));
  FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Boss1.X,Boss1.Y));
  FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Boss1.X,Boss1.Y));

  //ʉ
  SG.Play(CH_ENEMY1,PR_HIGH,SE_SHOOTDOWN2);

  MoveTo(gx,gy);
end;

destructor TDyingBoss1.Destroy;
begin
  inherited;
end;

procedure TDyingBoss1.Move(t:Integer);
var
  f2:TFlare2;
  m,s:Integer;
begin
  inherited;

  //
  if AgeT < 90 then begin
    with FOwner.Spr[Boss1.mySpr] do begin
      Width:=Width - t*2;
      Height:=Height - t*2;
    end;
  end;

  m:=256-AgeT Shl 1;
  s:=256;

  if AgeT > 75 then begin
    f2:=TFlare2.Create(FOwner, Boss1.X+(Random(256)-128) * m div s, Boss1.Y+(Random(256)-128) * m div s,0);
    f2.Scale(m,s);
    FOwner.Add(f2);
  end;

  //3/2bŔ
  if AgeT > 90 then begin
    FOwner.Add(TShockWave2.Create(FOwner, Boss1.X,Boss1.Y,0, $FFFF3030));
    FOwner.Add(TShockWave2.Create(FOwner, Boss1.X,Boss1.Y,2, $FF30FF30));
    FOwner.Add(TShockWave2.Create(FOwner, Boss1.X,Boss1.Y,4, $FF3030FF));
    FOwner.Add(TLensFlare1.Create(FOwner, Boss1.X + MvRandom(32),Boss1.Y + MvRandom(32),8));

    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Boss1.X,Boss1.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Boss1.X,Boss1.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Boss1.X,Boss1.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Boss1.X,Boss1.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Boss1.X,Boss1.Y));
    FOWner.Flash(clWhite);

    //ʉ
    SG.Play(CH_ENEMY1,PR_HIGH,SE_SHOOTDOWN3);

    Die;
  end;
end;

procedure TDyingBoss1.MoveTo(xx,yy:Integer);
begin
  X:=xx;
  Y:=yy;
end;

procedure TDyingBoss1.OnDie;
begin
  inherited;
end;





////////////////////////////
// q[[̂p^[
////////////////////////////

constructor TDyingHero.Create(owner:TMoverList; gx,gy:Integer);
var
  i:Integer;
begin
  inherited Create(owner);

  //蔻̏
  FAttr:=maThru;
  nTouchRect:=0;


  //_łq[[
  Hero:=TBlinker.Create(FOwner, S_Hero, gx,gy, 0,0, 30);
  FOwner.Add(Hero);
  FOwner.Spr[Hero.mySpr].Z:=Z_LOWER;


  //6
  For i:=0 to 2 do begin
    FOwner.Add(TFlare1.Create(FOwner, Hero.X+MvRandom(32), Hero.Y+MvRandom(32),i*8));
    FOwner.Add(TFlare2.Create(FOwner, Hero.X+MvRandom(32), Hero.Y+MvRandom(32),i*8+4));
  end;

  //΂̕
  FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Hero.X,Hero.Y));
  FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Hero.X,Hero.Y));
  FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Hero.X,Hero.Y));
  FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Hero.X,Hero.Y));
  FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Hero.X,Hero.Y));


  //ʉ
  SG.Play(CH_Hero2,PR_HIGH,SE_HeroDead);

  MoveTo(gx,gy);
end;

destructor TDyingHero.Destroy;
begin
  inherited;
end;

procedure TDyingHero.Move(t:Integer);
begin
  inherited;


  //1/2bŔ
  if AgeT > 30 then begin
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Hero.X,Hero.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Hero.X,Hero.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Hero.X,Hero.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Hero.X,Hero.Y));
    FOwner.Add(TSpark2.Create(FOwner,  16, 0,512, Hero.X,Hero.Y));
    FOWner.Flash(clRed);

    //ʉ
    SG.Play(CH_Hero2,PR_HIGH,SE_HeroDead);

    Die;
  end;
end;

procedure TDyingHero.MoveTo(xx,yy:Integer);
begin
  X:=xx;
  Y:=yy;
end;

procedure TDyingHero.OnDie;
begin
  inherited;
end;

end.
